// ************************************************
// Callback.cpp
//    
//	Sample file for SmallVR
//  This file was created to be used as a sample
//  to link SmallVR and FLTK
//
//  This file holds all the callback functions
//   
//
//  Authors: Marcio Serolli Pinho
//
//	Email: pinho@inf.pucrs.br		 
//	Homepages:
//		http://www.smallvr.org
//		http://grv.inf.pucrs.br
//		http://www.inf.pucrs.br/~pinho
//
//	Porto Alegre, Brazil, 2005.
// ************************************************
#include <stdio.h>

// include for SmallVR commands
#include <SmVr.h>

// include for FLTK objects
#include "SMVRWindow.h"


// ************************************************
// As it is necessary to acess the object
// you want to manipulate, you can declare all
// of them as 'extern'
// ************************************************
extern SmVR_CGeometricObject *Root, *TA, *QB, *Donut;
extern SmVRWindow *MainWindow;

// ************************************************
void CBOK(Fl_Button* A, Ogl* B)
{		
	Root->RotateBy(5,0,0,1);
	// After modifing the scene as you wish, it if 
	// necessary to force FLTK to redraw the 
	// OpenGL window. 
	// To do so, you will need to call the following 
    // methods of opengl frame
    // ->invalidate();
    // ->redraw();
    //  Fl::flush(); 
   

	// In order to access the opengl frame 
	// you have 2 options

	// Option 1: Using the main window object 
	// In this case the object that represents
	// this object(MainWindow) must be a global 
    // variable.
	MainWindow->win_opengl->invalidate();

	// Option 2: Using a parameter that gives
	// you access to the object you want.
	// To do so, you need to add this parameter
	// as "User Data" when you are building the 
    // interface with FLUID    
	B->redraw();

// In summary, you can choose one of 
// these tow forms

// MainWindow->win_opengl->invalidate();
// MainWindow->win_opengl->redraw();

// B->invalidate();
// B->redraw();
    Fl::flush(); 	
	
}

// ************************************************
void CbRotateTorus(Fl_Roller* A, Ogl* B)
{
    Donut->RotateBy(5,0,0,1);
    
    B->invalidate(); 
    B->redraw();
    Fl::flush(); 
}
