#include "tracker.h"
#include "SharedMemoryLib.h"
#include <cstdlib>
#include <iostream>
#include <fstream>

using namespace std;
//extern ofstream logfile;
extern float rotXL, rotYL, rotZL, transXL, transYL, transZL;
extern float rotXR, rotYR, rotZR, transXR, transYR, transZR;
extern float Transforms[12];//rotx, roty, rotz, transx, transy, transz

void WriteMemory(){
     for(int i = 0; i < 12; i++){
             WriteOnSharedMemory(Transforms[i], i);
     }
}

void CBTransXL(fltk::Slider* A, FakeTrackerGL* B){
     transXL = ((fltk::Slider*)A)->value()/100;
     Transforms[3] = transXL * 100.0;
     WriteMemory();
     B->invalidate();
     ((FakeTrackerGL*)B)->redraw();
     //if(B == NULL){ logfile << "nao foi" << endl; }
     //else logfile << "aham" << endl;
}

void CBTransYL(fltk::Slider* A, FakeTrackerGL* B){
     transYL = ((fltk::Slider*)A)->value()/100;
     Transforms[4] = transYL * 100.0;
     WriteMemory();
     B->invalidate();
     ((FakeTrackerGL*)B)->redraw();
}

void CBTransZL(fltk::Slider* A, FakeTrackerGL* B){
     transZL = ((fltk::Slider*)A)->value()/100;
     Transforms[5] = transZL * 100.0;
     WriteMemory();
     B->invalidate();
     ((FakeTrackerGL*)B)->redraw();
}

void CBRotXL(fltk::ThumbWheel* A, FakeTrackerGL* B){
     rotXL = ((fltk::ThumbWheel*)A)->value()*10;
     Transforms[0] = (float)rotXL;
     WriteMemory();
     B->invalidate();
     ((FakeTrackerGL*)B)->redraw();
}

void CBRotYL(fltk::ThumbWheel* A, FakeTrackerGL* B){
     rotYL = ((fltk::ThumbWheel*)A)->value()*10;
     Transforms[1] = (float)rotYL;
     WriteMemory();
     B->invalidate();
     ((FakeTrackerGL*)B)->redraw();
}

void CBRotZL(fltk::ThumbWheel* A, FakeTrackerGL* B){
     rotZL = ((fltk::ThumbWheel*)A)->value()*10;
     Transforms[2] = (float)rotZL;
     WriteMemory();
     B->invalidate();
     ((FakeTrackerGL*)B)->redraw();
}

/*************************************************************************/

void CBTransXR(fltk::Slider* A, FakeTrackerGLR* B){
     transXR = ((fltk::Slider*)A)->value()/100;
     Transforms[9] = transXR * 100.0;
     WriteMemory();
     B->invalidate();
     ((FakeTrackerGL*)B)->redraw();
     //if(B == NULL){ logfile << "nao foi" << endl; }
     //else logfile << "aham" << endl;
}

void CBTransYR(fltk::Slider* A, FakeTrackerGLR* B){
     transYR = ((fltk::Slider*)A)->value()/100;
     Transforms[10] = transYR * 100.0;
     WriteMemory();
     B->invalidate();
     ((FakeTrackerGL*)B)->redraw();
}

void CBTransZR(fltk::Slider* A, FakeTrackerGLR* B){
     transZR = ((fltk::Slider*)A)->value()/100;
     Transforms[11] = transZR * 100.0;
     WriteMemory();
     B->invalidate();
     ((FakeTrackerGL*)B)->redraw();
}

void CBRotXR(fltk::ThumbWheel* A, FakeTrackerGLR* B){
     rotXR = ((fltk::ThumbWheel*)A)->value()*10;
     Transforms[6] = (float)rotXR;
     WriteMemory();
     B->invalidate();
     ((FakeTrackerGL*)B)->redraw();
}

void CBRotYR(fltk::ThumbWheel* A, FakeTrackerGLR* B){
     rotYR = ((fltk::ThumbWheel*)A)->value()*10;
     Transforms[7] = (float)rotYR;
     WriteMemory();
     B->invalidate();
     ((FakeTrackerGL*)B)->redraw();
}

void CBRotZR(fltk::ThumbWheel* A, FakeTrackerGLR* B){
     rotZR = ((fltk::ThumbWheel*)A)->value()*10;
     Transforms[8] = (float)rotZR;
     WriteMemory();
     B->invalidate();
     ((FakeTrackerGL*)B)->redraw();
}



void CBClose(fltk::Button* A, fltk::Window* B){
     DestroySharedMemoryArea();
     B->destroy();
     exit(1);
}



