#include "FltkOpenGl.h"

#include <cstdlib>
#include "SharedMemoryLib.h"
#include "FakeTrackerGL.h"
#include "teapot.h"
#include <gl/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <fstream>
#include <iostream>

using namespace std;
//ofstream logfile("trombetta.txt");
fltk_opengl *mwindow;


void FakeTrackerGL::LookAt(){
     glMatrixMode(GL_PROJECTION);
        glLoadIdentity();
        gluPerspective(60, 260/145, 0.03, 500);
        
        glMatrixMode(GL_MODELVIEW);
        glLoadIdentity();

        gluLookAt(0, 2, 2, 0, 0, 0, 0.0f, 1.0f, 0.0f);
}

void FakeTrackerGL::drawCube() {
glEnable(GL_DEPTH_TEST);
glBegin(GL_QUADS);
      glColor3f(1.0, 0.0, 0.0);
      glVertex3f( -.5, -.5,  .5);
      glVertex3f(  .5, -.5,  .5);
      glVertex3f(  .5,  .5,  .5);
      glVertex3f( -.5,  .5,  .5);
glEnd();
     
glBegin(GL_QUADS);
      glColor3f(0.0, 0.0, 1.0);
      glVertex3f( -.5, -.5, -.5);
      glVertex3f(  .5, -.5, -.5);
      glVertex3f(  .5,  .5, -.5);
      glVertex3f( -.5,  .5, -.5);
glEnd();

glBegin(GL_QUADS);
      glColor3f(1.0, 1.0, 0.0);
      glVertex3f( -.5, -.5, -.5);
      glVertex3f( -.5, -.5,  .5);
      glVertex3f(  .5, -.5,  .5);
      glVertex3f(  .5, -.5, -.5);
glEnd();

glBegin(GL_QUADS);
      glColor3f(0.0, 1.0, 1.0);
      glVertex3f(  .5,  .5, -.5);
      glVertex3f(  .5,  .5,  .5);
      glVertex3f( -.5,  .5,  .5);
      glVertex3f( -.5,  .5, -.5);
glEnd();

glBegin(GL_QUADS);
      glColor3f(1.0, 0.0, 1.0);
      glVertex3f( -.5, -.5, -.5);
      glVertex3f( -.5,  .5, -.5);
      glVertex3f( -.5,  .5,  .5);
      glVertex3f( -.5, -.5,  .5);
glEnd();

glBegin(GL_QUADS);
      glColor3f(0.0, 1.0, 0.0);
      glVertex3f(  .5, -.5, -.5);
      glVertex3f(  .5, -.5,  .5);
      glVertex3f(  .5,  .5,  .5);
      glVertex3f(  .5,  .5, -.5);
glEnd();
//glColor3f(0.0, 0.0, 1.0);
//glutSolidTorus(.3, .7, 50, 50);
//glutSolidSphere(1, 1, 1);

}

void FakeTrackerGL::drawPlane()
{
     glColor3f(0,1,0);
     glBegin(GL_LINES);//-1.5~1.5
     //verticais: E->R
        glVertex3f( -1.5, 0,  1.5);
        glVertex3f( -1.5, 0, -1.5);
        
        glVertex3f( -1, 0,  1.5);
        glVertex3f( -1, 0, -1.5);
        glVertex3f(-.5, 0,  1.5);
        glVertex3f(-.5, 0, -1.5);
        glVertex3f(  0, 0,  1.5);
        glVertex3f(  0, 0, -1.5);
        glVertex3f( .5, 0,  1.5);
        glVertex3f( .5, 0, -1.5);
        glVertex3f(  1, 0,  1.5);
        glVertex3f(  1, 0, -1.5);
        
        glVertex3f(  1.5, 0,  1.5);
        glVertex3f(  1.5, 0, -1.5);
     //horizontais: F->T
        glVertex3f( -1.5, 0,  1.5);
        glVertex3f(  1.5, 0,  1.5);
        
        glVertex3f( -1.5, 0,  1);
        glVertex3f(  1.5, 0,  1);
        glVertex3f( -1.5, 0, .5);
        glVertex3f(  1.5, 0, .5);
        glVertex3f( -1.5, 0,  0);
        glVertex3f(  1.5, 0,  0);
        glVertex3f( -1.5, 0,-.5);
        glVertex3f(  1.5, 0,-.5);
        glVertex3f( -1.5, 0, -1);
        glVertex3f(  1.5, 0, -1);
        
        glVertex3f( -1.5, 0, -1.5);
        glVertex3f(  1.5, 0, -1.5);
     glEnd();
};



void FakeTrackerGL::draw() {
    if (!valid()) {
        LookAt();
    }
    glEnable(GL_DEPTH_TEST);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glPushMatrix(); 
//    glScalef(.05,.05,.05);
    glTranslatef(transXL, transYL, transZL);
    //don't even ask
    glRotatef(rotXL,1,0,0); 
    glRotatef(rotYL,0,1,0);
    glRotatef(rotZL,0,0,1);
    //drawCube();
    DrawTeapot();
    glPopMatrix();
    glPushMatrix();
    glTranslatef(0, -1.5, 0);
    drawPlane();
    glPopMatrix();    
    glPushMatrix();
    glTranslatef(1.5, 0, 0);
    glRotatef(90,0,0,1);
    drawPlane();
    glPopMatrix();
    glPushMatrix();
    glTranslatef(-1.5, 0, 0);
    glRotatef(90,0,0,1);
    drawPlane();
    glPopMatrix();    
    glPushMatrix();
    glTranslatef(0, 0, -1.5);
    glRotatef(90,1,0,0);
    drawPlane();
    glPopMatrix();
};



int main (int argc, char* argv[])
{  
    OpenSharedMemory(argv[1]);
    //CreateSharedMemoryArea(argv[1]);
    argv[1] = "";
    argc = 0;
    
WriteOnSharedMemory(0, 6);


    mwindow = new fltk_opengl(argc, argv);
    return mwindow->run1();
}

