//
// Copyright 2005 by Mauro Charo, Rafael Rieder.
// Porto Alegre, Brazil.
//
// This library is free software; you can redistribute it and/or modify it under the
// terms of the GNU Library General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
// PARTICULAR PURPOSE. See the GNU Library General Public License for more details.
//
// You should have received a copy of the GNU Library General Public License along with
// this library; if not, write to the Free Software Foundation, Inc., 59 Temple Place,
// Suite 330, Boston, MA 02111-1307 USA.
//
// Please report bugs & problems to maurocharao@yahoo.com.br or rafaelrieder@gmail.com
//

// *************************************************************************************
//  About.cxx
//  Create a menu About using FLTK 1.1.x and FLUID 1.1.0 toolkits
// *************************************************************************************
#include "About.h"
#include <FL/Fl.H>

// *************************************************************************************
// Constructor...: Define text about SmallVR SceneEditor
// *************************************************************************************
About::About() : Fl_Window((Fl::w() - 330) / 2, (Fl::h() - 175) / 2, 330, 175) {
  box(FL_FLAT_BOX);
  labelAbout = new Fl_Box(0, 0, 330, 35, "About");
  labelAbout->labeltype(FL_ENGRAVED_LABEL);
  labelAbout->labelsize(36);

  texto = new Fl_Box(10, 40, 310, 100,
    "SmallVR Scene Editor\nDesenvolvido por:\n  Mauro Charo: maurocharao@@yahoo.com.br,\n  Rafael Rieder: rafaelrieder@@gmail.com.\n       2005");
  texto->box(FL_ENGRAVED_FRAME);
  texto->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

  btOk = new Fl_Return_Button(127, 145, 75, 25, "&OK");
  btOk->callback((Fl_Callback*)About::callbackOk, this);
  set_modal();
  end();
}

// *************************************************************************************
// Method.....: callbackOk(Fl_Return_Button *bt, void *janela)
// Function...: When "Ok Button" pressed, hide the window :-P
// *************************************************************************************
void About::callbackOk(Fl_Return_Button *bt, void *janela) {
  ((About*)janela)->hide();
}
