//
// Copyright 2005 by Mauro Charo, Rafael Rieder.
// Porto Alegre, Brazil.
//
// This library is free software; you can redistribute it and/or modify it under the
// terms of the GNU Library General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
// PARTICULAR PURPOSE. See the GNU Library General Public License for more details.
//
// You should have received a copy of the GNU Library General Public License along with
// this library; if not, write to the Free Software Foundation, Inc., 59 Temple Place,
// Suite 330, Boston, MA 02111-1307 USA.
//
// Please report bugs & problems to maurocharao@yahoo.com.br or rafaelrieder@gmail.com
//
#ifndef _ACAO_H_
#define _ACAO_H_
#include "SmVR.h"
#include <vector>
using namespace std; // Para o vector

typedef enum {
  ROT,   // Rotacao com a TrackBall
  ROT_X, // Rotacao em X
  ROT_Y, // Rotacao em Y
  ROT_Z, // Rotacao em Z
  ESC_X,
  ESC_Y,
  ESC_Z,
  TRANS_X,
  TRANS_Y,
  TRANS_Z,
  REMOVER,
  INSERIR,
  RESETAR,
  RENOMEAR
} tipo_acao;

class Acao {
public:
  Acao(SmVR_CGeometricObject *obj, tipo_acao tipo, float valor = 0.0, char *str_valor = NULL, SmVR_Matrix mRot = NULL);
  ~Acao();
  static bool existeLoader(SmVR_CObjFromFile *loader);
  static void limpa();
  static void limpaDesfazer();
  static void limpaRefazer();
  static void adicionaAcao(SmVR_CGeometricObject *obj, tipo_acao tipo, float valor = 0.0, char *str_valor = NULL, SmVR_Matrix mRot = NULL);
  static bool podeDesfazer();
  static void desfazer();
  static void refazer();
protected:
  static vector<Acao*> vetorDesfazer; // Guarda as acoes para Desfazer
  static vector<Acao*> vetorRefazer;  // Guarda as acoes para Refazer
  char *nome, *str_valor;
  tipo_acao tipo;
  float valor;
  SmVR_Matrix m, mRot;
  SmVR_CObjFromFile *loader;
};
#endif
