//
// Copyright 2005 by Mauro Charo, Rafael Rieder.
//
// This library is free software; you can redistribute it and/or modify it under the
// terms of the GNU Library General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
// PARTICULAR PURPOSE. See the GNU Library General Public License for more details.
//
// You should have received a copy of the GNU Library General Public License along with
// this library; if not, write to the Free Software Foundation, Inc., 59 Temple Place,
// Suite 330, Boston, MA 02111-1307 USA.
//
// Please report bugs & problems to maurocharao@yahoo.com.br or rafaelrieder@gmail.com
//
#ifndef _Gl_Group_H_
#define _Gl_Group_H_
#include <FL/Fl_Gl_Window.H>
#include "SmVR.h"

typedef enum {
  NENHUM,
  PERSPECTIVA,
  FRONTAL,
  TRASEIRA,
  DIREITA,
  ESQUERDA,
  SUPERIOR,
  INFERIOR
} tipo_vista;

class Gl_Group : public Fl_Gl_Window {
public:
  static const char* label_vista[8];
  int anguloVisao;

  Gl_Group(int X, int Y, int W, int H, tipo_vista tipo = NENHUM);
  void draw();
  int handle(int event);
  void SetPosicaoLuz(float x, float y, float z, float alfa);
  void SetTipo(tipo_vista tipo);
protected:
  float val_near;
  float posicaoLuz1[4];
  int inicializou;
  int mouseX, mouseY;
  tipo_vista tipo;
  static SmVR_Matrix m, mr; // Para a trackball
  static float curquat[4], mquat[4][4]; // Para a trackball
  static int spinning; // Para a trackball
  static int especMaterial;
  static float luzAmbiente[4];
  static float luzDifusa[4]; // Cor do objeto
  static float luzEspecular[4]; // Brilho do objeto
  static float especularidade[4]; // Capacidade de brilho do material
  static void callbackTrackball(void *val);
};
#endif
