//
// Copyright 2005 by Mauro Charo, Rafael Rieder.
// Porto Alegre, Brazil.
//
// This library is free software; you can redistribute it and/or modify it under the
// terms of the GNU Library General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
// PARTICULAR PURPOSE. See the GNU Library General Public License for more details.
//
// You should have received a copy of the GNU Library General Public License along with
// this library; if not, write to the Free Software Foundation, Inc., 59 Temple Place,
// Suite 330, Boston, MA 02111-1307 USA.
//
// Please report bugs & problems to maurocharao@yahoo.com.br or rafaelrieder@gmail.com
//
#ifndef _PREFERENCIAS_H_
#define _PREFERENCIAS_H_

#include <FL/Fl_Box.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Return_Button.H>
#include <FL/Fl_Value_Input.H>
#include <FL/Fl_Window.H>

class Preferencias : public Fl_Window {
public:
  int numMaxDesfazer, espacamentoGrid, numLinhasGridX, numLinhasGridZ;
  int cenarioMinX, cenarioMinY, cenarioMinZ;
  int cenarioMaxX, cenarioMaxY, cenarioMaxZ;
  float diagonalCenario;

  Preferencias();
  void show();
protected:
  Fl_Box *labelPreferencias;
  Fl_Group *grupoTamCenario;
  Fl_Value_Input *inputCenarioMinX;
  Fl_Value_Input *inputCenarioMaxX;
  Fl_Value_Input *inputCenarioMinY;
  Fl_Value_Input *inputCenarioMaxY;
  Fl_Value_Input *inputCenarioMinZ;
  Fl_Value_Input *inputCenarioMaxZ;
  Fl_Value_Input *inputNumMaxDesfazer;
  Fl_Value_Input *inputEspacamentoGrid;
  Fl_Return_Button *btOk;
  Fl_Button *btCancel;

  static void callbackOk(Fl_Return_Button *bt, void *val);
  static void callbackCancel(Fl_Button *bt, void *val);
};
#endif
