//
// Copyright 2005 by Mauro Charo, Rafael Rieder.
// Porto Alegre, Brazil.
//
// This library is free software; you can redistribute it and/or modify it under the
// terms of the GNU Library General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
// PARTICULAR PURPOSE. See the GNU Library General Public License for more details.
//
// You should have received a copy of the GNU Library General Public License along with
// this library; if not, write to the Free Software Foundation, Inc., 59 Temple Place,
// Suite 330, Boston, MA 02111-1307 USA.
//
// Please report bugs & problems to maurocharao@yahoo.com.br or rafaelrieder@gmail.com
//

// *************************************************************************************
//  Splash.cxx
//  Create a splash screen using FLTK 1.1.x and FLUID 1.1.0 toolkits
// *************************************************************************************
#include "Splash.h"
#include "SceneEditor.h"
#include "SplashImg.xpm"
#include <FL/Fl.H>
#include <FL/Fl_Pixmap.H>

// *************************************************************************************
// Constructor...: Define the splash screen details
// *************************************************************************************
Splash::Splash() : Fl_Window((Fl::w() - 534) / 2, (Fl::h() - 304) / 2, 534, 304) {
  box(FL_THIN_UP_FRAME);
  boxImgFundo = new Fl_Box(2, 2, 530, 300);
  boxImgFundo->box(FL_NO_BOX);
  boxImgFundo->image(new Fl_Pixmap(SplashImg));

  titulo = new Fl_Box(120, 0, 285, 35, "SmallVR Scene Editor 1.0");
  titulo->labeltype(FL_ENGRAVED_LABEL);
  titulo->labelcolor(FL_BACKGROUND2_COLOR);
  titulo->labelsize(24);

  rodape = new Fl_Box(125, 272, 285, 25, "2005 - Todos direitos reservados");
  rodape->labeltype(FL_ENGRAVED_LABEL);
  rodape->labelcolor(FL_BACKGROUND2_COLOR);

  clear_border();
  end();
  Fl::add_timeout(2.0, callback, this);
}

// *************************************************************************************
// Method.....: callback(void *param)
// Function...: Start the splash screen
// *************************************************************************************
void Splash::callback(void *param) {
  Splash* jan = (Splash*)param;
  janela->inicializaJanela();
  jan->hide();
  delete jan;
}
