// *******************************************************
//
//  MaterialOBJ.cpp
//
//
// *******************************************************

#include <stdio.h>
#include <string.h>
#include <string>
#ifdef WIN32
#include <malloc.h>
#endif
//#include <stdlib>
#include <iostream>
#include <fstream>

#include "OBJ_Texture_LIB.h"


static FILE *MatFile;
static int CurrentMaterial;
std::string path;


// *******************************************************
// void ImprimeMateriais(TObject *o)
//
//
// *******************************************************
void ImprimeMateriais(TObject *o)
{
    int i;
	// Imprime os materiais
	printf("\n\n>>>>>>>>>>MATERIAIS in MTL file<<<<<<<<\n");
	for (i=0; i < o->nMaterials; i++)
	{
		printf("Material: (%d) - %s - (%6.3f %6.3f %6.3f) \n", i, o->Materials[i].Name,
				o->Materials[i].dif.r, o->Materials[i].dif.g, o->Materials[i].dif.b);
	}
}
// *******************************************************
// void TryToGetMaterialParameter(char *line, char *parameter, TRGB &value)
//		get RGB parameter from material properties
//
// *******************************************************
void TryToGetMaterialParameterStr(char *line, char const *parameter, char *str)
{
	char Part1[200];
	if (strstr(line, parameter))
	{
		sscanf(line, "%s%s", Part1, str);
		if (strcmp(Part1, parameter))
		{
			printf("Unexpected material property!\n");
			printf("Funtion Name: %s\n", __FUNCTION__ );
			printf("Line read:%s\n", line);
			printf("Token expected: %s\n", parameter );
			//"Press ENTER.",line);
			//getchar();
			return;
		}
		line[0] = '\0';
	}
}


// *******************************************************
// void TryToGetMaterialParameter(char *line, char *parameter, TRGB &value)
//		get RGB parameter from material properties
//
// *******************************************************
void TryToGetMaterialParameterRGB(char *line, char const *parameter, TRGB &color)
{
	char Part1[200];
	TRGB temp;
	if (strstr(line, parameter))
	{
		sscanf(line, "%s%f%f%f", Part1, &temp.r, &temp.g, &temp.b);
		if (strcmp(Part1, parameter))
		{
			printf("Unexpected material property!\n");
			printf("Funtion Name: %s\n", __FUNCTION__ );
			printf("Line read:%s\n", line);
			printf("Token expected: %s\n", parameter );
			return;
		}
		color = temp;
		line[0] = '\0';
	}

}
// *******************************************************
// void TryToGetMaterialParameterFloat(char *line, char *parameter, float &value)
//
//
// *******************************************************
void TryToGetMaterialParameterFloat(char *line, char const *parameter, float &value)
{
	char Part1[200];
	if (strstr(line, parameter))
	{
		sscanf(line, "%s%f", Part1, &value);
		if (strcmp(Part1, parameter))
		{
			printf("Unexpected material property!\n");
			printf("Funtion Name: %s\n", __FUNCTION__ );
			printf("Line read:%s\n", line);
			printf("Token expected: %s\n\n", parameter );
			return;
		}
		line[0] = '\0';
	}
}

// *******************************************************
// int IsThisMaterialUsed(TObject *o, char *MatName)
//
//
// *******************************************************
int IsThisMaterialUsed(TObject *o, char *MatName)
{
	int i;

	for (i=0; i < o->nMaterialsUsed; i++)
	{
		if (!strcmp(MatName, o->Materials[i].Name))
			return 1;
	}
	return 0;
}
// *******************************************************
// void ProcessMaterial()
//
//
// *******************************************************
void ProcessMaterial(char *line, TObject *o)
{
	char Part1[500], Part2[500];

	// check to see if this is really a material specification
	sscanf(line, "%s%s", Part1, Part2);
	if (strcmp(Part1, "newmtl")) // if it is not a material specification
	{
		printf("Error parsing material file !\nPress ENTER.");
	    printf("Funtion Name: %s\n", __FUNCTION__ );
		return;
	}

	strcpy(o->Materials[CurrentMaterial].Name, Part2);
//printf("Material read : %s\n", o->Materials[CurrentMaterial].Name);

	do // read the material file until it is finished
	{
		if (fgets(line, 500,MatFile) == NULL)
			return;
        line[strlen(line)-1] = '\0';
        //printf("Linha: >>%s<<", line);
		if (strstr(line,"newmtl")) // restart the parsing of a new material
		{
			CurrentMaterial++;
			ProcessMaterial(line,o);
		}
		// Process material properties
		TryToGetMaterialParameterStr(line, "map_Kd", o->Materials[CurrentMaterial].TextureName);
		TryToGetMaterialParameterRGB(line, "Kd", o->Materials[CurrentMaterial].dif);
		TryToGetMaterialParameterRGB(line, "Ka", o->Materials[CurrentMaterial].amb);
		TryToGetMaterialParameterRGB(line, "Ks", o->Materials[CurrentMaterial].spe);
		TryToGetMaterialParameterFloat(line, "Ns", o->Materials[CurrentMaterial].Ns);
		TryToGetMaterialParameterFloat(line, "d", o->Materials[CurrentMaterial].d);
		TryToGetMaterialParameterFloat(line, "illum", o->Materials[CurrentMaterial].illum);
	} while (!feof(MatFile));

}

// *******************************************************
// void ReadMaterialFile(char *MaterialLibraryName, TObject *o)
//
//
// *******************************************************
void ReadMaterialFile(char *MaterialLibraryName, TObject *o)
{
	char line[210];
	int i;

	CurrentMaterial=0;

	MatFile = fopen(MaterialLibraryName, "r");

	if (MatFile == NULL)
	{
        //MatFile = fopen(MaterialLibraryName, "r");
        std::string subs = o->Name;
        path = subs.substr(0,subs.size()-strlen(MaterialLibraryName));
        subs = subs.substr(0,subs.size()-3);
        subs = subs + "mtl";
        std::cout << path << std::endl;
        std::cout << subs << std::endl;
       	MatFile = fopen(subs.c_str(), "r");
        if (MatFile == NULL)
        {
            printf("No MATERIAL file !!\n");
    		//getchar();
	    	return;
        }
	}

	// Count the total number of materials
	o->nMaterials = 0;
	while (!feof(MatFile))
	{
		fgets(line, 200,MatFile);
		if (line[0] == '#')
			continue;
		if (strstr(line, "newmtl"))
		{
			o->nMaterials++;
		}
	}
	o->Materials = (TMaterial *) malloc (o->nMaterials * sizeof (TMaterial));
	for (i=0; i < o->nMaterials; i++)
	{
		strcpy(o->Materials[i].TextureName, "");
	}

    rewind (MatFile);
	while (!feof(MatFile))
	{
		fgets(line, 200,MatFile);
		if (line[0] == '#')
			continue;
		if (strstr(line, "newmtl"))
		{
			ProcessMaterial(line, o);
		}
	}

	fclose(MatFile);

// Load the Textures for the materials

	for (i=0; i < o->nMaterials; i++)
	{
		if (o->Materials[i].TextureName[0]) // if there is a texture file name
		{
			bool flag = false;
			int j = 0;
			while(j < i && !flag)
			{
			  if(!strcmp(o->Materials[i].TextureName,o->Materials[j].TextureName))
			  {
			    o->Materials[i].TextObj = o->Materials[j].TextObj;
			    o->Materials[i].flag = o->Materials[j].flag;
			    flag = !flag;
			  }
  			  else j++;
			}
			if(!flag)
            {
              //printf("%s\n",o->Materials[i].TextureName);
              char vet[200];
              std::string aux = o->Materials[i].TextureName;
              std::ifstream file;
              file.open(o->Materials[i].TextureName);
           	  if(file.bad() || !file.is_open())
              {
                  unsigned int lastOc = 0, auxui = aux.find("/",0);
                  if(auxui != std::string::npos)
                  {
                      while(auxui != std::string::npos)
                      {
                          lastOc = auxui;
                          auxui = aux.find("/",lastOc+1);
                      }
                      aux = aux.substr(lastOc+1,aux.length());
                      aux = path + aux;
                      strcpy(vet, aux.c_str());
                  }
                  else
                  {
                      auxui = aux.find("\\",lastOc);
                      if(auxui != std::string::npos)
                      {
                          while(auxui != std::string::npos)
                          {
                              lastOc = auxui;
                              auxui = aux.find("/",lastOc+1);
                          }
                          aux = aux.substr(lastOc+1,aux.length());
                          aux = path + aux;
                          strcpy(vet, aux.c_str());
                      }
                      else
                      {
                          aux = path + aux;
                          strcpy(vet, aux.c_str());
                      }
                  }
                  o->Materials[i].flag = o->Materials[i].TextObj.Load(vet);
              }
              else
              {
                  file.close();
                  o->Materials[i].flag = o->Materials[i].TextObj.Load(o->Materials[i].TextureName);
                  strcpy(vet,o->Materials[i].TextureName);
              }
              printf("Reading Texture %s\n",vet);
            }
		}
	}

	//ImprimeMateriais(o);

}


// *******************************************************
// int SearchForMaterialNumber(char MaterialName)
//		given the Material name this function returns its
//	number.
// *******************************************************
int SearchForMaterialNumber(TObject *o, char *MaterialName)
{
	int i;
	for(i=0; i < o->nMaterials; i++)
	{
		if(!strcmp(o->Materials[i].Name, MaterialName))
		{
//printf("Material found: %s (%d)\n",MaterialName, i);
			return i;
		}
	}
	printf("Invalid Material name (%s) in object\n", MaterialName);
	return -1;
}
