
// SmVR_COBJLoader.h

#ifndef _SmVR_COBJLoader_
#define _SmVR_COBJLoader_

#define USE_RAPID 1

#include "OBJ_Texture_Lib.h"
#include "RAPID.H"
#include "RAPID_model_Reader.h"

class SmVR_COBJLoader:public SmVR_CObjFromFile
{
	public:
		SmVR_COBJLoader (void);
		SmVR_COBJLoader (int rapid);

		virtual ~SmVR_COBJLoader();

		int Load(char const *filename);
		void Render();
		void Remove();
		void GetBoundaries(SmVR_CPoint *min, SmVR_CPoint *max);
		void PrintEnvelope();
		void InvertNormalOrientation(void);
		//RAPID
		int Collided(SmVR_CObjFromFile *obj,SmVR_Matrix mtx1,SmVR_Matrix mtx2,int mode);
		RAPID_model* GetCollisionModel() {return &collisionModel;};
		TVertices *GetVertices() { return obj.Vertices; };
		void GetFace(int n, int v[3]);
		int GetNFaces() { return obj.nFaces;};
		char *GetFileName();


	private:
		TObject obj;
		RAPID_model collisionModel;
		int useRAPID;

};


#endif

