#ifdef WIN32
#include <windows.h>
#endif

#include <gl/gl.h>

#include "OBJ.h"

OBJ::OBJ ()
{

	opaqueCount = translucentCount = texCoordCount = verticesCount = 0;

	normals = texCoords = vertices = 0;

}

/*
*	Add this lines before draw the object
*	glEnableClientState (GL_NORMAL_ARRAY);
*	glEnableClientState (GL_TEXTURE_COORD_ARRAY);
*	glEnableClientState (GL_VERTEX_ARRAY);
*	and this after the draw
*	glDisableClientState (GL_NORMAL_ARRAY);
*	glDisableClientState (GL_TEXTURE_COORD_ARRAY);
*	glDisableClientState (GL_VERTEX_ARRAY);
*/
void OBJ::drawOpaque ()
{

	glNormalPointer (GL_FLOAT, 0, normals);

	glTexCoordPointer (3, GL_FLOAT, 0, texCoords);

	glVertexPointer (3, GL_FLOAT, 0, vertices);

	for (int index = 0; index < opaqueCount; index++)
	{

		opaque[index].draw ();

	}

}

void OBJ::drawTranslucent ()
{

	glNormalPointer (GL_FLOAT, 0, normals);

	glTexCoordPointer (3, GL_FLOAT, 0, texCoords);

	glVertexPointer (3, GL_FLOAT, 0, vertices);

	for (int index = 0; index < translucentCount; index++)
	{

		translucent[index].draw ();

	}

}

OBJ::~OBJ ()
{

	delete normals;

	delete texCoords;

	delete vertices;

}
