#include <fstream>

#include <map>

#include "OBJMaterialManager.h"

#include "OBJ.h"

#ifndef OBJLOADER_H
#define OBJLOADER_H

class OBJLoader
{

private:

	float * auxVv, * auxNv, * auxTv;

	int auxVc, auxNc, auxTc, facesCount;

	OBJMaterialManager * matManager;

	OBJ * auxOBJ;

	std::map<char *, OBJ *> objs;

	std::map<char *, OBJ *>::iterator objsIt;

	std::ifstream * myfile;

	static OBJLoader single;

	OBJLoader ();

	void calcSizes ();

	void getVertices ();

	void getVerticeNormals ();

	void getTextureCoords ();

	void getFaces ();

	void passHeader (char * fileName);

public:

	static OBJLoader * getInstance ();

	OBJ * loadOBJ (char * fileName);

	void clear ();

	~OBJLoader ();

};

#endif