#ifdef WIN32
#include <windows.h>
#endif

#include <gl/gl.h>

#include "OBJMaterial.h"

OBJMaterial::OBJMaterial ()
{

	ambient[0] = diffuse[0] = 0.6510f;

	ambient [1] = ambient[2] = diffuse[1] = diffuse[2] = 0.898f;

	emission[0] = emission[1] = emission[2] = 0.0f;

	specular[0] = specular[1] = specular[2] = 0.35f;

	ambient[3] = diffuse[3] = emission[3] = specular[3] = 1.0f;

	shininess = 32.0f;

	textureID = 0;

	translucent = false;

}

void OBJMaterial::useMaterial ()
{

	glMaterialfv (GL_FRONT, GL_AMBIENT, ambient);

	glMaterialfv (GL_FRONT, GL_DIFFUSE, diffuse);

	glMaterialfv (GL_FRONT, GL_EMISSION, emission);

	glMaterialfv (GL_FRONT, GL_SPECULAR, specular);

	glMaterialf (GL_FRONT, GL_SHININESS, shininess);

	if (textureID)
	{

		if (!glIsEnabled (GL_TEXTURE_2D)) glEnable (GL_TEXTURE_2D);
		
		glBindTexture (GL_TEXTURE_2D, textureID);

	}

}

OBJMaterial::~OBJMaterial ()
{

	// Nothing to free

}