#include <fstream>

#include <map>

#include <string>

#include "OBJMaterial.h"

#ifndef OBJMATERIALMANAGER_H
#define OBJMATERIALMANAGER_H

class OBJMaterialManager
{

private:

	std::map<std::string, OBJMaterial *> materials;

	std::map<std::string, OBJMaterial *>::iterator materialIt;

	static OBJMaterialManager single;

	OBJMaterialManager ();

	void loadNewMaterial (std::ifstream * myfile, std::string materialName, std::string pathName);

public:

	static OBJMaterialManager * getInstance ();

	OBJMaterial * getMaterial (char * matName);

	void loadMaterials (char * fileName);

	void clear ();

	~OBJMaterialManager ();

};

#endif