#ifdef WIN32
#include <windows.h>
#endif

#include <gl/gl.h>

#include "SOIL/SOIL.h"

#include "OBJTextureManager.h"

OBJTextureManager OBJTextureManager::single;

OBJTextureManager::OBJTextureManager ()
{}

unsigned int OBJTextureManager::loadTexture (char * fileName)
{

	textureIt = textures.find (fileName);

	if (textureIt != textures.end ())
		return textureIt->second;

	unsigned int text = 0;

	text = SOIL_load_OGL_texture (fileName, SOIL_LOAD_AUTO, SOIL_CREATE_NEW_ID,
		SOIL_FLAG_INVERT_Y | SOIL_FLAG_NTSC_SAFE_RGB | SOIL_FLAG_COMPRESS_TO_DXT);

	textures[fileName] = text;

	return text;

}

void OBJTextureManager::clear ()
{

	textureIt = textures.begin ();

	while (textureIt != textures.end ())
	{

		glDeleteTextures (1, &(textureIt->second));

		textureIt++;

	}

	textures.clear ();

}

OBJTextureManager::~OBJTextureManager ()
{

	clear ();

}