#include "RAPID_model_Reader.h"
// *******************************************************
// RAPID_model_Read
//		Creates the RAPID structure
//
// *******************************************************

void RAPID_model_Read (TObject *o, RAPID_model *collisionModel)
{
	int f, vt;
	double p[3][3];

	collisionModel->BeginModel();

	for (f=0; f< o->nFaces; f++)
	{
		vt = o->Faces[f][0].v; // get the number of the vertice
		p[0][0] = o->Vertices[vt].x;
		p[0][1] = o->Vertices[vt].y;
		p[0][2] = o->Vertices[vt].z;

		vt = o->Faces[f][1].v; // get the number of the vertice
		p[1][0] = o->Vertices[vt].x;
		p[1][1] = o->Vertices[vt].y;
		p[1][2] = o->Vertices[vt].z;

		vt = o->Faces[f][2].v; // get the number of the vertice
		p[2][0] = o->Vertices[vt].x;
		p[2][1] = o->Vertices[vt].y;
		p[2][2] = o->Vertices[vt].z;

		collisionModel->AddTri(p[0], p[1], p[2], f);
	}
	collisionModel->EndModel();

	//printf("%d Triangles\n",collisionModel->num_tris);
}


// ******************************************************
//  SmVR_RAPIDMatrixConversion
//
//     Converts the SmallVR transformation matrix to
//	RAPID Translation and Rotation Matrices
//     SmallVR uses a 4x4 transformation matrix
//     RAPID uses
//			- a 1x3 Translation matrix
//			- a 3x3 Rotation matrix
//
// ******************************************************
void SmVR_RAPIDMatrixConversion( SmVR_Matrix M_SmVR, // SVE matrix
							                   double MR[3][3], // rotation matrix
							                   double MT[3])    // translation matrix
{
	int i, j;

  // copy the rotation part of the matrix
	// note that yhe matrix is transposed
	for (i=0;i<3;i++)
		for (j=0;j<3;j++)
			MR[i][j] = M_SmVR[j][i];

  // copy the translation part of the matrix
	for (i=0;i<3;i++)
		MT[i] = M_SmVR[3][i];

}
