#ifndef _TIMER_H_
#define _TIMER_H_

#ifdef __GNU__
#include <sys/time.h>
#include <unistd.h>
#endif

#include <windows.h>

class Timer{
  private:
    LARGE_INTEGER t0;
    int           isRunning;

  public:
    Timer(){
      isRunning = 0;
    }

    static LARGE_INTEGER getTime(void){
      LARGE_INTEGER tv;
      QueryPerformanceCounter(&tv);
      return tv;
    }

    static double elapsed(LARGE_INTEGER t1, LARGE_INTEGER t0){
      LARGE_INTEGER freq;
      QueryPerformanceFrequency(&freq);
      return ((double) (t1.QuadPart - t0.QuadPart)) / ((double) freq.QuadPart);
    }

    void start(void){
      isRunning = 1;
      t0 = getTime();
    }

    double stop(void){
      isRunning = 0;
      return elapsed(getTime(), t0);
    }

    double partial(void){
      return elapsed(getTime(), t0);
    }

    int running(){
      return isRunning;
    }
};
#endif
