// ************************************************
// SmVR_CDevice.h
//	Implement the VIRTUAL class for device drives 
//
//  Author: Marcio Serolli Pinho
//	Email: pinho@inf.pucrs.br		 
//	Homepages:
//		http://www.smallvr.org
//		http://grv.inf.pucrs.br
//		http://www.inf.pucrs.br/~pinho
//
//	Porto Alegre, Brazil, 2002.
// ************************************************

#include "../SmVR_CGeometricObject.h"


#ifndef _SmVR_CDevice_
#define _SmVR_CDevice_

class SmVR_CDevice {

	public:

		virtual ~SmVR_CDevice(void);
		virtual int Init(void *);
		virtual int Read(void *);
		virtual int Reset(void *);	
		virtual void Bind(int nSensor, SmVR_CGeometricObject *o );
		virtual void UpdateAllSensors (void);
		virtual void UpdateAllSensors (int tx,int ty,int tz,int rx,int ry,int rz);
		virtual void UpdateAllSensors (int rx,int ry,int rz);
		virtual void SetExtraData(void *);

	private:
		void *ExtraData;

};
#endif
