/*************************************************
 **
 ** StereoIglasses.h
 **
 ** Author: Mrcio Serolli Pinho
 ** E-Mail: pinho@inf.pucrs.br
 ** Version: 1.0
 ** Date: April, 4th, 2003.
 **
 *************************************************/

#include <windows.h>
#include <stdio.h>
#include <gl\gl.h>
#include <gl\glu.h>
#include <gl\glut.h>


typedef struct {
   double x,y,z;
} XYZ;

typedef struct {
   XYZ vp;              /* View position           */
   XYZ vd;              /* View direction vector   */
   XYZ vu;              /* View up direction       */
   XYZ pr;              /* Point to rotate about   */
   double focallength;  /* Focal Length along vd   */
   double aperture;     /* Camera aperture         */
   double eyesep;       /* Eye separation          */
   int screenwidth,screenheight;
} CAMERA;


void StereoIglasses_Init(int Largura, int Altura );
void StereoIglasses_PosicOlhoEsquerdo();
void StereoIglasses_PosicOlhoDireito();
void StereoIglasses_HabilitaOlhoEsquerdo();
void StereoIglasses_HabilitaOlhoDireito();
void StereoIglasses_CameraPos(float px, float py, float pz, float ax, float ay, float az);

// Rotina para mudana de resoluo de vdeo
#define VM_640x480 1
#define VM_800x600 2
#define VM_1024x768 3
#define VM_1400x1050 4
void ChangeResolution(int mode);

void RemoveBorder (void);


