/*************************************************
 **
 ** MultipleCopy.cpp
 **		creating multiple copies from a single 
 ** object
 **
 *************************************************/
#include <windows.h>
#include <gl\glut.h>

#include "../Source/SmVR.h"
#include "OBJ\SmVR_COBJLoader.h"
//#include <3DS\SmVR_C3DSLoader.h>
//#include <3DS_2\SmVR_C3DSLoader2.h>
//#include <3DS_3\SmVR_C3DSLoader3.h>

#include "Utilities.h"


SmVR_CPoint User(0,0,50);

SmVR_CGeometricObject *rootObject;

// **********************************************************************
//  void DefineLight(void)
//
//
// **********************************************************************
void DefineLuz(void)
{
  GLfloat LuzAmbiente[]   = {0.2f, 0.2f, 0.2f } ;
  GLfloat LuzDifusa[]   = {0.5f, 0.5f, 0.5f, 1.0f };
  GLfloat LuzEspecular[] = {0.2f, 0.1f, 0.1f, 1.0f };
  GLfloat PosicaoLuz0[]  = {0.0f, 3.0f, 0.0f, 1.0f };
  GLfloat PosicaoLuz1[]  = {-3.0f, -3.0f, 0.0f, 1.0f };
  GLfloat Especularidade[] = {1.0f, 1.0f, 1.0f, 1.0f };

   // ****************  Fonte de Luz 0

   glEnable ( GL_COLOR_MATERIAL );


   // Habilita o uso de iluminao
  glEnable(GL_LIGHTING);

  // Ativa o uso da luz ambiente
  glLightModelfv(GL_LIGHT_MODEL_AMBIENT, LuzAmbiente);
  // Define os parametros da Luz nmero Zero
  glLightfv(GL_LIGHT0, GL_AMBIENT, LuzAmbiente);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, LuzDifusa  );
  glLightfv(GL_LIGHT0, GL_SPECULAR, LuzEspecular  );
  glLightfv(GL_LIGHT0, GL_POSITION, PosicaoLuz0 );
  glEnable(GL_LIGHT0);

  // Ativa o "Color Tracking"
  glEnable(GL_COLOR_MATERIAL);

  // Define a reflectancia do material
  glMaterialfv(GL_FRONT,GL_SPECULAR, Especularidade);

  // Define a concentrao do brilho.
  // Quanto maior o valor do Segundo parametro, mais
  // concentrado ser o brilho. (Valores vlidos: de 0 a 128)
  glMateriali(GL_FRONT,GL_SHININESS,51.2);

  // ****************  Fonte de Luz 1

  // Ativa o uso da luz ambiente
  glLightModelfv(GL_LIGHT_MODEL_AMBIENT, LuzAmbiente);
  // Define os parametros da Luz nmero Zero
  glLightfv(GL_LIGHT1, GL_AMBIENT, LuzAmbiente);
  glLightfv(GL_LIGHT1, GL_DIFFUSE, LuzDifusa  );
  glLightfv(GL_LIGHT1, GL_SPECULAR, LuzEspecular  );
  glLightfv(GL_LIGHT1, GL_POSITION, PosicaoLuz1 );
  glEnable(GL_LIGHT1);

  // Ativa o "Color Tracking"
  glEnable(GL_COLOR_MATERIAL);

  // Define a reflectancia do material
  glMaterialfv(GL_FRONT,GL_SPECULAR, Especularidade);

  // Define a concentrao do brilho.
  // Quanto maior o valor do Segundo parametro, mais
  // concentrado ser o brilho. (Valores vlidos: de 0 a 128)
  glMateriali(GL_FRONT,GL_SHININESS,20);

}

// **********************************************************************
//  void PosicUser()
//
//
// **********************************************************************
void PosicUser()
{
	// Set the clipping volume
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(90,1,0.01,2000);

	// Set the user Position
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(User.X,User.Y, User.Z,
		      User.X,User.Y, User.Z-3,
			  0.0f,1.0f,0.0f);
}
// **********************************************************************
//  void reshape( int w, int h )
//		trata o redimensionamento da janela OpenGL
//
// **********************************************************************
void reshapeFunc( int w, int h )
{
	// Prevent a divide by zero, when window is too short
	// (you cant make a window of zero width).
	if(h == 0)
		h = 1;

	//WindowRatio = 1.0f * w / h;
	// Reset the coordinate system before modifying
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	// Set the viewport to be the entire window
    glViewport(0, 0, w, h);

	PosicUser();

}
/*************************************************
 ** Init Function.
 *************************************************/
void init (void) {

	setBackgroundColor (BLACK);
	glEnable (GL_DEPTH_TEST);

	glColorMaterial (GL_FRONT, GL_AMBIENT_AND_DIFFUSE);
	glEnable (GL_CULL_FACE);

}



/*************************************************
 ** Keyboard Function.
 *************************************************/
void keyboardFunc (unsigned char key, int x, int y) {

	switch (key) {
		case 27:
			exit(0);
			break;
		case 'a':
			rootObject->ScaleBy(1.1f,1.1f,1.1f);
			break;
		case 's':
			rootObject->ScaleBy(0.9f,0.9f,0.9f);
			break;
	}

}



/*************************************************
 ** Keyboard Special Function.
 *************************************************/
void specialFunc (int key, int x, int y) {

	switch (key) {
		case GLUT_KEY_UP:
			rootObject->RotateBy (-5, 1, 0, 0);
			break;

		case GLUT_KEY_DOWN:
			rootObject->RotateBy (5, 1, 0, 0);
			break;

		case GLUT_KEY_LEFT:
			rootObject->RotateBy (-5, 0, 1, 0);
			break;

		case GLUT_KEY_RIGHT:
			rootObject->RotateBy (5, 0, 1, 0);
			break;

		case GLUT_KEY_PAGE_UP:
			rootObject->RotateBy (-5, 0, 0, 1);
			break;

		case GLUT_KEY_PAGE_DOWN:
			rootObject->RotateBy (5, 0, 0, 1);
			break;
	}

}



/*************************************************
 ** Display Function.
 *************************************************/
void displayFunc (void) {

	DefineLuz();
	glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glDisable(GL_CULL_FACE);
	PosicUser();

	glColor3f(1,0,0);
	
	rootObject->Render();
	glutSwapBuffers();

}



/*************************************************
 ** Main Function.
 *************************************************/
void main (int argc, char **argv) 
{

	glutInit (&argc, argv);
	glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
	glutInitWindowPosition (0, 0);
	glutInitWindowSize (500, 500);
	glutCreateWindow ("Creating multiple copies from an object....");	


	rootObject = SmVR_Init(NULL);  //Cena3.SmallVR");
	init();

	// cria um onjeto
	SmVR_CGeometricObject *original, *Copias[10];

	SmVR_CObjFromFile *ArqOBJ = new SmVR_COBJLoader();	
	if (!ArqOBJ->Load("..//TestFiles//Objetos3D//heater.obj"))
	{
		printf ("SmallVR SCENE - Error reading file !\n");
		printf ("Program Aborted.\n");
		exit(1);
	}
	original = new SmVR_CGeometricObject("Aviao", ArqOBJ);

	
	for(int i=0; i<10; i++)
	{
		Copias[i] = new SmVR_CGeometricObject ("Uma Copia");
		Copias[i]->CopyRenderFunctionFromObject(original);
		rootObject->AddChild(Copias[i]);

		// poe a cpia do objeto na mesma posio que a do objeto original
		Copias[i]->TranslateBy(3, 0, -1);  
		
		Copias[i]->ScaleBy(2,2,2);	// idem para a escala
		
		Copias[i]->TranslateBy(0,4*i-15,0); // move a cpia...
	}
	glutReshapeFunc (reshapeFunc);
	glutDisplayFunc (displayFunc);	
	glutIdleFunc (displayFunc);
	glutKeyboardFunc (keyboardFunc);	
	glutSpecialFunc (specialFunc);


	glutMainLoop();

}