
#include <stdlib.h>
#include <stdio.h>

#ifdef WIN32
#include <windows.h>
#endif

#include <GL\gl.h>
#include <GL\glaux.h>
#include <GL\glut.h>

#include "CameraClass.h"

#define TAM_PIXEL 3

// **********************************************************************
//
//	Constructor
// **********************************************************************
CameraClass::CameraClass(int ShowDialog)
{

	gHeight = gWidth = 0;

	myVideoCap = imVideoCaptureCreate();
	if (!myVideoCap)
	{
		printf("No Capture Device!\n");
	}
	
	imVideoCaptureConnect(myVideoCap, 0);
	imVideoCaptureLive(myVideoCap, 1);

	if (ShowDialog)
		imVideoCaptureShowDialog(myVideoCap, 0, NULL); // o indice 0 escolhe qual o dialogo a ser mostrado.
		
//	imVideoCaptureShowFormatDialog(myVideoCap, NULL);

	imVideoCaptureGetImageSize(myVideoCap, &gWidth, &gHeight);

	SetSize(gWidth, gHeight);			
	

}
// **********************************************************************
//
//	Destructor
// **********************************************************************
CameraClass::~CameraClass()
{
	imVideoCaptureDisconnect(myVideoCap);
	imVideoCaptureDestroy(myVideoCap);
	ImageClass::Delete();
}

// **********************************************************************
//
//	Update
// **********************************************************************
void CameraClass::Update()
{
	if (!imVideoCaptureLive(myVideoCap, -1))
	{
		printf("Retornando....\n");
		return;
	}
	imVideoCaptureFrame(myVideoCap, GetImagePtr(), IM_RGB|IM_PACKED, 1000);
//	imVideoCaptureFrame(myVideoCap, GetImagePtr(), 1000);
}

