// ************************************************
//    RAComSmallVR.cpp
//	Sample file for SmallVR. 
//	This file integrates the camera image capture 
//	and the SmallVR lib.
//	To capture the image from the camera we use 
//  a library provided by Antonio Scuri (scuri@tecgraf.puc-rio.br)
//
//  Author: Marcio Serolli Pinho
//	Email: pinho@inf.pucrs.br		 
//	Homepages:
//		http://www.smallvr.org
//		http://grv.inf.pucrs.br
//		http://www.inf.pucrs.br/~pinho
//
//	Porto Alegre, Brazil, 2004.
// ************************************************

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#ifdef WIN32
#include <windows.h>
#endif

#include <GL\gl.h>
#include <GL/glut.h>


// SmallVR header files
#include "SmVR.h"

#include "Devices\IGlasses\SmVR_CIGlasses.h"
#include "Devices\IsotrackII\SmVR_CIsotrack.h"


// Image capture header files
//#include "imvideocapture.h"
#include "CameraClass.h"

//imVideoCapture* myVideoCap;
//GLuint  gTexCapedImage;
//int gHeight = 0, gWidth = 0;
//unsigned char* gData = NULL;

CameraClass *Camera;
ImageClass *ImageCopy;

int showPhantom=1;

GLUquadricObj *Esfera;


// Global variables for the graphics
float WindowRatio;

// Root Object to represent the entire scene
SmVR_CGeometricObject *RootObject, *RealObjects, *VirtualObjects;
SmVR_CGeometricObject *UserObject, *TargetObject, *HandObject, *PointerObject, *Tracker, *Pai;
SmVR_CGeometricObject *Obj1, *SateliteObj1, *PivotObj1;
SmVR_CGeometricObject *Obj2, *Fator;


SmVR_CPoint PosObj1(0, -9, 48.54);
//SmVR_CPoint EscObj1(0, -3, 37);
//SmVR_CPoint PosObj1(-163, -25, 580);
SmVR_CPoint EscObj1(4.3, 17.8, 4.3);

//UserObject->TranslateBy(465,0.3,650);

//
//minimo 56
// Parmetros para o cilindro
//SmVR_CPoint PosObj2(9, 0, -50);
//SmVR_CPoint EscObj2(5, 16, 5);

int lateral = 1;



//fator: 1.618
//int angulo;
SmVR_CPoint look(-2.17, -.08, 46.89);
//(2, -.1, 46.52)

// Parmetros para a esfera
SmVR_CPoint PosObj2(0, -4.4, -97.08);
//SmVR_CPoint EscObj2(1, 1, 1);
//SmVR_CPoint PosObj2(-30.598, 40, 510.4);
//SmVR_CPoint EscObj2(1.2, 1.2, 1.2);
//SmVR_CPoint PosObj2(-60, 40, 500);
SmVR_CPoint EscObj2(3.5 , 3.5, 3.5);


SmVR_CDevice *Iglasses=NULL;

SmVR_CDevice *Isotrack;

GLfloat Vermelho[] = {1,0,0 };
GLfloat Azul[] = {0,0,1 };
GLfloat Verde[] = {0,1,0 };
GLfloat Amarelo[] = {1,1,0 };
GLfloat Marron[] = {0.60, 0.40, 0.12 };
GLfloat Laranja[] = { 0.98, 0.625,0.12 };
GLfloat Rosa[] = {0.98, 0.00, 0.47};
GLfloat Roxo[] = {0.60, 0.40, 0.70};





// **********************************************************************
//  void DefineLuz(void)
//
//
// **********************************************************************
void DefineLight(void)
{
  
  GLfloat LuzAmbiente[]   = {0.2f, 0.2f, 0.2f } ;
  GLfloat LuzDifusa[]   = {0.6f, 0.6f, 0.6f, 1.0f };
  GLfloat LuzEspecular[] = {0.9f, 0.9f, 0.9f, 1.0f };
  GLfloat PosicaoLuz0[]  = {0.0f, 4.0f, 0.0f, 1.0f };
  GLfloat PosicaoLuz1[]  = {0.0f, 4.0f, 0.0f, 1.0f };
  GLfloat Especularidade[] = {1.0f, 1.0f, 1.0f, 1.0f };

   // ****************  Light source 0

  glEnable ( GL_COLOR_MATERIAL );

   // Enable the use of light
  glEnable(GL_LIGHTING);

  // Set ambient light
  glLightModelfv(GL_LIGHT_MODEL_AMBIENT, LuzAmbiente);
  // Define light 0 parameters
  glLightfv(GL_LIGHT0, GL_AMBIENT, LuzAmbiente);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, LuzDifusa  );
  glLightfv(GL_LIGHT0, GL_SPECULAR, LuzEspecular  );
  glLightfv(GL_LIGHT0, GL_POSITION, PosicaoLuz0 );
  glEnable(GL_LIGHT0);

  // Enable the Color Tracking
  glEnable(GL_COLOR_MATERIAL);

  // Define the material reflectance
  glMaterialfv(GL_FRONT,GL_SPECULAR, Especularidade);

  // Define shininess concentration
  // As higher this value is the more concentrate
  // the shininess will be. The valid values are form 0 to 128
  glMaterialf(GL_FRONT,GL_SHININESS,51.2f);

   // ****************  Light source 1

  glLightModelfv(GL_LIGHT_MODEL_AMBIENT, LuzAmbiente);

  glLightfv(GL_LIGHT1, GL_AMBIENT, LuzAmbiente);
  glLightfv(GL_LIGHT1, GL_DIFFUSE, LuzDifusa  );
  glLightfv(GL_LIGHT1, GL_SPECULAR, LuzEspecular  );
  glLightfv(GL_LIGHT1, GL_POSITION, PosicaoLuz1 );
  glEnable(GL_LIGHT1);

  glEnable(GL_COLOR_MATERIAL);

  glMaterialfv(GL_FRONT,GL_SPECULAR, Especularidade);

  glMateriali(GL_FRONT,GL_SHININESS,20);

}


void linha()
{
	glBegin(GL_LINES);
		glColor3f(0.0f, 0.0f, 1.0f);
		glVertex2i(10, 0);
		glVertex2i(-10, 0);
		glVertex2i(0, 10);
		glVertex2i(0, -10);
	glEnd();
}
int DrawLine(void *p)
{
	linha();	
	return 1;
}
// **********************************************************************
//  void DesenhaCubo()
//
//
// **********************************************************************
void DrawCube()
{

	glBegin ( GL_QUADS );
		// Front Face
		glNormal3f(0,0,1);
		glVertex3f(-0.5, 0, 0.5);
		glVertex3f( 0.5, 0, 0.5);
		glVertex3f( 0.5, 0.5, 0.5);
		glVertex3f(-0.5, 0.5, 0.5);
		// Back Face
		glNormal3f(0,0,-1);
		glVertex3f(-0.5, 0, -0.5);
		glVertex3f(-0.5, 0.5, -0.5);
		glVertex3f( 0.5, 0.5, -0.5);
		glVertex3f( 0.5, 0, -0.5);
		// Top Face
		glNormal3f(0,1,0);
		glVertex3f(-0.5, 0.5, -0.5);
		glVertex3f(-0.5, 0.5,  0.5);
		glVertex3f( 0.5, 0.5,  0.5);
		glVertex3f( 0.5, 0.5, -0.5);
		// Bottom Face
		glNormal3f(0,-1,0);
		glVertex3f(-0.5, 0, -0.5);
		glVertex3f( 0.5, 0, -0.5);
		glVertex3f( 0.5, 0,  0.5);
		glVertex3f(-0.5, 0,  0.5);
		// Right face
		glNormal3f(1,0,0);
		glVertex3f( 0.5, 0,-0.5);
		glVertex3f( 0.5, 0.5, -0.5);
		glVertex3f( 0.5, 0.5,  0.5);
		glVertex3f( 0.5, 0, 0.5);
		// Left Face
		glNormal3f(-1,0,0);
		glVertex3f(-0.5, 0, -0.5);
		glVertex3f(-0.5, 0, 0.5);
		glVertex3f(-0.5, 0.5,  0.5);
		glVertex3f(-0.5, 0.5, -0.5);
	glEnd();

}

// **********************************************************************
//  void DrawSphere()
//
//
// **********************************************************************
int DrawSphere(void *p) 
{

	    GLfloat *Cor;
	
	Cor = (GLfloat*) p;

	if (Cor)
		glColor3fv(Cor);

//	gluSphere(Esfera, escala*3.6/*4.7*/, 20,20);
	gluSphere(Esfera, 1/*4.7*/, 20,20);
	
	return 1;
}
// **********************************************************************
//  void DrawCylinder()
//
//
// **********************************************************************
int DrawCylinder(void *p) 
{
	glutSolidCube(1);
	return 1;
}

// **********************************************************************
// int DrawTest(void *p)
//
// **********************************************************************
int DrawTest(void *p) 
{ 
    GLfloat *Cor;
	
	Cor = (GLfloat*) p;

	if (Cor)
		glColor3fv(Cor);
	DrawCube(); 	

  return 1;
} 


// ****************************************************************
//  radial_invtransf
//
//
// ****************************************************************
void radial_invtransf(int x, int y, float *xl, float *yl, float k1, float xc, float yc)
{
  float aux;
  x -= (int)xc;
  y -= (int)yc;
  aux = 1.0f + k1*(x*x + y*y);
  *xl = x*aux + xc;
  *yl = y*aux + yc;
}
// ****************************************************************
//  void RadialDistortion(ImageClass *Source, ImageClass *Dest)
//
//
// ****************************************************************
void RadialDistortion(ImageClass *Source, ImageClass *Dest)
{
  float xl, yl;
  float xc = float(Source->SizeX()/2.);
  float yc = float(Source->SizeY()/2.);
  int diag = (int)sqrt(float(Source->SizeX()*Source->SizeX()+ Source->SizeY()*Source->SizeY()));
  unsigned char r,g,b;
  float k1 = -0.2; // choose a initial value for "k1"
  

  k1 /= (diag * diag);
         
  for (int y = 0; y < Source->SizeY(); y++)
  {
    for (int x = 0; x < Source->SizeX(); x++)
    {
      radial_invtransf(x, y, &xl, &yl, k1, xc, yc);
                   
      // if inside the original image broad area
      if (xl > 0.0 && yl > 0.0 && xl < Source->SizeX() && yl < Source->SizeY())
      {
		  Source->ReadPixel(xl,yl,r,g,b); 	
          Dest->DrawPixel(x,y,r,g,b);			
      }

    }

  }

}

// ****************************************************************
// void DrawCameraImage()
//
//     a exbio da imagem na tela sem a alterao do Zbuffer far 
//  com que os objetos desenhados antes disto (fantasmas) na tela 
//	desapaream somente do COLOR_BUFFER mas permaneam 
//  no DEPTH_BUFFER.
//		Isto ir pemitir que a seguir os objetos virtuais sejam 
//  desenhados levando em conta o desenho dos objetos fantasmas 
// ****************************************************************
void DrawCameraImage()
{

	// reseta os parmetros da Cmera
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();

	int w = glutGet(GLUT_WINDOW_WIDTH);
	int h = glutGet(GLUT_WINDOW_HEIGHT);
	// Set the viewport to be the entire window
    glViewport(0, 0, w, h); 
	gluOrtho2D(0,w,0,h);
	
	glMatrixMode (GL_MODELVIEW);
	glPushMatrix();
	glLoadIdentity();

	// Desabilita o uso do Zbuffer antes de colocar a imagem da 
	// cmera na tela
	glDisable(GL_DEPTH_TEST);
	
	ImageCopy->SetZoomH(2);
	ImageCopy->SetZoomV(2);
	// Exibe imagem da cmera
	//Camera->Display();

	RadialDistortion(Camera, ImageCopy);
	ImageCopy->Display();

	// Reabilita o uso do Zbuffer 
	glEnable(GL_DEPTH_TEST);

	// Restaura Parmetros da Camera OpenGL 
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	
	glMatrixMode (GL_MODELVIEW);
	glPopMatrix();		

}

// **********************************************************************
//  void PosicUser()
//
//
// **********************************************************************
void PosicUser()
{

	SmVR_CPoint	User, Target, Zero (0,0,0);
	
	UserObject->GetPointInOCS(Zero, &User, RootObject);
	TargetObject->GetPointInOCS(Zero, &Target, RootObject);

	// Set the clipping volume
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity ();
	gluPerspective (19.21267181,WindowRatio,0.01,500);
	
	
	
/*	GLfloat matrizproj[4][4];

	matrizproj[0][0] = 2.440;   matrizproj[0][1] =  0.000;   matrizproj[0][2] =    0.000; matrizproj[0][3] = 0.000;
	matrizproj[1][0] = 0.000;   matrizproj[1][1] = -2.977;   matrizproj[1][2] =    0.000; matrizproj[1][3] = 0.000;
	matrizproj[2][0] = 0.041;   matrizproj[2][1] =  0.011;   matrizproj[2][2] =    1.020; matrizproj[2][3] = 1.000;
	matrizproj[3][0] = 0.000;   matrizproj[3][1] =  0.000;   matrizproj[3][2] = -101.010; matrizproj[3][3] = 0.000;

	glLoadMatrixf(&matrizproj[0][0] );


	// Set the user Position
	glMatrixMode (GL_MODELVIEW);
	glLoadIdentity ();*/
	
	gluLookAt (User.X, User.Y, User.Z,
		       Target.X, Target.Y, Target.Z,
			   0.0f,1.0f,0.0f);

}
// **********************************************************************
//  void reshape( int w, int h )
//		trata o redimensionamento da janela OpenGL
//
// **********************************************************************
void reshape( int w, int h )
{
	// Prevent a divide by zero, when window is too short
	// (you cant make a window of zero width).
	if(h == 0)
		h = 1;

	WindowRatio = 1.0f * w / h;
	// Reset the coordinate system before modifying
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	// Set the viewport to be the entire window
    glViewport(0, 0, w, h);

	PosicUser();

}
// **********************************************************************
//  void display( void )
//
//
// **********************************************************************
void display( void )
{

	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

	PosicUser();

	glMatrixMode(GL_MODELVIEW);

	PivotObj1->RotateBy(2,0,1,0);

	DefineLight();
	// Read the data from the tracker and
	// update all the BIND objects
	if(Isotrack){
		Isotrack->UpdateAllSensors();
		//UserObject->TranslateBy(0,-100,0);
	}
	
	if (Iglasses)
	   Iglasses->UpdateAllSensors();

    if (showPhantom)
	{
		// Desenha Imagem da Cmera
		DrawCameraImage();
		// Desenha Objetos REAIS
		RealObjects->Render();
	}
	else{
		// Desenha Objetos REAIS
		RealObjects->Render();
		// Desenha Imagem da Cmera
		DrawCameraImage();
	}



	//Desenha Objetos VIRTUAIS
// 	VirtualObjects->Render();
 	RootObject->Render();
	
	glutSwapBuffers();
}

/*************************************************
 ** Keyboard Special Function.
 *************************************************/
void specialFunc (int key, int x, int y) {

	switch (key) {
		case GLUT_KEY_PAGE_UP:
			break;

		case GLUT_KEY_PAGE_DOWN:
			break;

		case GLUT_KEY_LEFT:
			UserObject->TranslateBy(-1, 0,0);
			//UserObject->RotateBy(2,0,1,0);
			break;

		case GLUT_KEY_RIGHT:
			UserObject->TranslateBy(1, 0,0);
			//UserObject->RotateBy(-2,0,1,0);
			break;

		case GLUT_KEY_UP:
			UserObject->TranslateByOnOBJCS (0,0,+1, TargetObject);
			break;

		case GLUT_KEY_DOWN:
			UserObject->TranslateByOnOBJCS (0,0,-1, TargetObject);
			break;
	}

}

// **********************************************************************
//  void keyboard ( unsigned char key, int x, int y )
//
//
// **********************************************************************
void keyboard ( unsigned char key, int x, int y )  
{

	SmVR_CPoint	User, Target, tracker, Zero (0,0,0);

	switch ( key ) 
	{
	    case 27:        // Teminate the program
			if(Isotrack)
				delete Isotrack;
			exit(0);    
			break;  
		case 'a' : 
			PosObj1.X--;
			Obj1->TranslateBy(-1,0,0);
			PivotObj1->TranslateBy(-1,0,0);
			break;
		case 's' : 
			PosObj1.X++;
			Obj1->TranslateBy(1,0,0);
			PivotObj1->TranslateBy(1,0,0);
			break;
		case 'w' : 
			PosObj1.Z--;
			Obj1->TranslateBy(0,0,-1);
			PivotObj1->TranslateBy(0,0,-1);
			break;
		case 'z' : 
			PosObj1.Z++;
			Obj1->TranslateBy(0,0,1);
			PivotObj1->TranslateBy(0,0,1);
			break;
		case 'A' : 
			PosObj2.X--;
			Obj2->TranslateBy(-1,0,0);
			break;
		case 'S' : 
			PosObj2.X++;
			Obj2->TranslateBy(1,0,0);
			break;
		case 'W' : 
			PosObj2.Z--;
			Obj2->TranslateBy(0,0,-1);
			break;
		case 'Z' : 
			PosObj2.Z++;
			Obj2->TranslateBy(0,0,1);
			break;

		case 'y': PivotObj1->RotateBy(10,0,1,0);
				  break;
		case 'Y': PivotObj1->RotateBy(-10,0,1,0);
				  break;
		//EscObj1
				break;        				
        // Rotate the User's Hand
		case 'x': HandObject->RotateBy(10,1,0,0);
				  break;
		case 'X': HandObject->RotateBy(-10,1,0,0);
				  break;
		case 'c': HandObject->RotateBy(10,0,1,0);
				  break;
		case 'C': HandObject->RotateBy(-10,0,1,0);
				  break;
		case 'r':// Call Isotrack reset function
		case 'R':// Call Iglasses reset function
			  	 // It is necessary to apply a type cast because
				 // SmVR_CDevice class has no Reset method
			/*if (Iglasses)
			{
				aux =  (SmVR_CIGlasses *) Iglasses;  
				Iglasses->Reset(NULL);
			}*/
			if(Isotrack)
				Isotrack->Reset(NULL);
			break;
		case 'f': showPhantom = !showPhantom;
				  break;


		case 'm': UserObject->RotateBy( 10, 1, 0, 0);
				  break;
		case 'M': UserObject->RotateBy( -10, 1, 0, 0);
				  break;
		case 'n': UserObject->RotateBy( 180, 0, 1, 0);
				  //printf("%
				  break;
		case 'N': UserObject->RotateBy( -180, 0, 1, 0);
				  break;

		case 'h': case 'H':

				UserObject->GetPointInOCS(Zero, &User, RootObject);
				TargetObject->GetPointInOCS(Zero, &Target, RootObject);
				Tracker->GetPointInOCS(Zero, &tracker, RootObject);
				printf("User: (%f, %f, %f)\n", User.X, User.Y, User.Z);
				printf("Alvo: (%f, %f, %f)\n", Target.X, Target.Y, Target.Z);
				printf("Tracker: (%f, %f, %f)\n", tracker.X, tracker.Y, tracker.Z);
				break;

		case 'k': 	// Bind it to Isotrack tracker number 1	
			if(Isotrack){
				Isotrack->Bind(0, Tracker);
				Isotrack->Reset(NULL);
			}
			break;
					

  }

 /* printf("Pos OBJ1: %6.3f, %6.3f, %6.3f - Esc: %6.3f, %6.3f, %6.3f\n",
		PosObj1.X, PosObj1.Y, PosObj1.Z,
		EscObj1.X, EscObj1.Y, EscObj1.Z);

  printf("Pos OBJ2: %6.3f, %6.3f, %6.3f - Esc: %6.3f, %6.3f, %6.3f\n",
		PosObj2.X, PosObj2.Y, PosObj2.Z,
		EscObj2.X, EscObj2.Y, EscObj2.Z);*/

}

// **********************************************************************
//  void init(void)
//		Inicializa os parmetros globais de OpenGL
//
// **********************************************************************
void init(void)
{
	glClearColor(0.0f, 0.0f, 0.0f, 1.0f); // Fundo de tela preto
	glColorMaterial ( GL_FRONT, GL_AMBIENT_AND_DIFFUSE );

	glShadeModel(GL_SMOOTH);						
	glColorMaterial ( GL_FRONT, GL_AMBIENT_AND_DIFFUSE );
	glEnable(GL_DEPTH_TEST);
	glEnable ( GL_CULL_FACE );

	// Camera Initialization
	Camera = new CameraClass(0);
	Camera->SetPos(1,0);

	// make a auxiliary image
	ImageCopy = new ImageClass(Camera->SizeX(), Camera->SizeY());
	
}

// **********************************************************************
//  void SetupTheUser ()
//
//
// **********************************************************************
void SetupTheUser ()
{

	// Create the user object
	UserObject = new SmVR_CGeometricObject("User Object");

	Pai = new SmVR_CGeometricObject("Pai Tracker");

	//Pai->RotateBy(90, 0, 1, 0);
	
	// Create the target object
	TargetObject = new SmVR_CGeometricObject("Target Object", DrawLine);
//	TargetObject->TranslateBy(0,0,10);

	TargetObject->TranslateBy(look);

	// Create a hand without Geometry
	Tracker = new SmVR_CGeometricObject("Tracker Object");

	
	
	if(Isotrack){
	//			Isotrack->Bind(0, Tracker);
	//			Isotrack->Reset(NULL);
		}


	// Add the USER to the scene
	// Create an object to be BIND to the tracker
	RootObject->AddChild(Pai);
	Pai->AddChild(Tracker);
	Tracker->AddChild(UserObject);
	// Add the Target to the User 
	//UserObject->AddChild(TargetObject);
	RootObject->AddChild(TargetObject);

	
	// Move the USER to its initial position
	// (REMEMBER: the Target, the Hand and the Pointer are also moved !!) 
	
	if(lateral)
	{
		//UserObject->TranslateBy(50.967, -1, 48.54);
		//UserObject->RotateBy(-90, 0, 1, 0);
		UserObject->TranslateBy(-24.27, 12.944, 24.27);
		//UserObject->RotateBy(-45, 0, 1, 0);
	}

	// Move the TARGET to its initial position
	// (Remember: the translation is allways in the PARENT CS) 
	//TargetObject->TranslateBy(0,0,-10);


/*
    // Move the HAND to its initial position
	HandObject->TranslateBy(0, 0, -3);

	// Resize the pointer
	PointerObject->ScaleBy(0.1, 0.1,1);
	// Move the pointer to place its base on the user's hand
	PointerObject->TranslateBy(0,0,-0.5);
*/
  

	// initialize the tracker device
	/*Iglasses = new SmVR_CIGlasses();
	if (Iglasses->Init("COM1"))
	{	
	 // Bind the User to Iglasses tracker number 0	
	 Iglasses->Bind(0, UserObject);
	}
	else 
	{
		delete Iglasses;
		Iglasses = NULL;
		printf("Working without a tracker !\n");
	}*/

// =============
}

// **********************************************************************
//  void SetupScene ()
//
//
// **********************************************************************
void SetupScene()
{
	

	RealObjects = new SmVR_CGeometricObject("Real Objects");
 	VirtualObjects = new SmVR_CGeometricObject("Virtual Objects");	
	
	RootObject->AddChild(VirtualObjects);



	// Create REAL object
	Obj1 = new SmVR_CGeometricObject("Obj1", DrawTest);
	Obj1->SetRenderFunctionData(Vermelho);
	Obj1->TranslateBy(PosObj1);
	Obj1->ScaleBy(EscObj1);


	// Create REAL object
/*	Obj2 = new SmVR_CGeometricObject("Obj2", DrawTest);
	Obj2->SetRenderFunctionData(Verde);
	Obj2->TranslateBy(PosObj2);
	Obj2->ScaleBy(EscObj2);
*/
	Esfera = gluNewQuadric();

	// Create REAL object
	Obj2 = new SmVR_CGeometricObject("Esfera", DrawSphere);
	Obj2->SetRenderFunctionData(Verde);
	Obj2->TranslateBy(PosObj2);
	Obj2->ScaleBy(EscObj2);

	/*temp = new SmVR_CGeometricObject("tmp", DrawSphere);
	temp->SetRenderFunctionData(Amarelo);
	temp->TranslateBy(2, -.1, 46.52);
	temp->ScaleBy(.2, .2, .2);
	RootObject->AddChild(temp);*/

	/*temp = new SmVR_CGeometricObject("tmp", DrawSphere);
	temp->SetRenderFunctionData(Amarelo);
	temp->TranslateBy(0, -15, 66);
	temp->ScaleBy(7, 7, 7);
	RealObjects->AddChild(temp);*/

	// Add an object to the scene
	RealObjects->AddChild(Obj1);
	RealObjects->AddChild(Obj2);


	//Fator = new SmVR_CGeometricObject("Fator");
	//Fator->ScaleBy(fator);
	//Fator->AddChild(RealObjects);

	// Create VIRTUAL objects
	PivotObj1 = new SmVR_CGeometricObject("Pivot Object1");
	PivotObj1->TranslateBy(PosObj1);

	SateliteObj1 = new SmVR_CGeometricObject("Satelite Obj1",DrawTest);
	SateliteObj1->SetRenderFunctionData(Amarelo);
	SateliteObj1->TranslateBy(PosObj1);
	SateliteObj1->TranslateBy(20,0,0);
	SateliteObj1->ScaleBy(EscObj1);
	//SateliteObj1->ScaleBy(fator);


	PivotObj1->AddChild(SateliteObj1);

	VirtualObjects->AddChild(PivotObj1);

//	CubeObject->TranslateBy(PosObj1);
//	CubeObject->SetRenderFunctionData(Marron);

}
// ****************************************************************
// ****************************************************************
void myIdle()
{

	Camera->Update();	
	glutPostRedisplay();
		
}

// **********************************************************************
//  void main ( int argc, char** argv )
//
//
// **********************************************************************
void main ( int argc, char** argv )   
{

	// GLUT initialization
	glutInit            ( &argc, argv ); 
	glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
	glutInitWindowPosition (0,0);
	//glutInitWindowSize  ( 352, 288 ); 
	glutInitWindowSize  ( 704, 576 ); 
	//glutInitWindowSize  ( 500, 500 ); 
	glutCreateWindow    ( "SmallVR and Camera Test" ); 
		
	// initialize OpenGL parameters
	init ();
	
	// initialize the library
	RootObject = SmVR_Init(NULL);


	// initialize the tracker device
	//Isotrack = NULL;
	//Isotrack = new SmVR_CIsotrack();
	//Isotrack->Init("COM1");

	SetupScene();
	
	SetupTheUser ();

	// GLUT stuff
	glutDisplayFunc ( display );  
	glutReshapeFunc ( reshape );
	glutKeyboardFunc ( keyboard );
	glutSpecialFunc (specialFunc);
	glutIdleFunc ( myIdle );

	glutMainLoop ( );          

}

