// ****************************************************************
//  TestRadialDist.cpp
//
//
// ****************************************************************


#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <time.h>
#include <GL/glut.h>
#include "CameraClass.h"



CameraClass *Camera;
ImageClass *ImageCopy;

void myIdle()
{

	Camera->Update();	
	glutPostRedisplay();  // fora o redesenho da tela


//printf("Idle....\n");
	
}
// ****************************************************************
//  radial_invtransf
//
//
// ****************************************************************
void radial_invtransf(int x, int y, float *xl, float *yl, float k1, float xc, float yc)
{
  float aux;
  x -= (int)xc;
  y -= (int)yc;
  aux = 1.0f + k1*(x*x + y*y);
  *xl = x*aux + xc;
  *yl = y*aux + yc;
}
// ****************************************************************
//  void RadialDistortion(ImageClass *Source, ImageClass *Dest)
//
//
// ****************************************************************
void RadialDistortion(ImageClass *Source, ImageClass *Dest)
{
  float xl, yl;
  float xc = float(Source->SizeX()/2.);
  float yc = float(Source->SizeY()/2.);
  int diag = (int)sqrt(float(Source->SizeX()*Source->SizeX()+ Source->SizeY()*Source->SizeY()));
  unsigned char r,g,b;
  float k1 = -0.2; // choose a initial value for "k1"
  

  k1 /= (diag * diag);
         
  for (int y = 0; y < Source->SizeY(); y++)
  {
    for (int x = 0; x < Source->SizeX(); x++)
    {
      radial_invtransf(x, y, &xl, &yl, k1, xc, yc);
                   
      // if inside the original image broad area
      if (xl > 0.0 && yl > 0.0 && xl < Source->SizeX() && yl < Source->SizeY())
      {
		  Source->ReadPixel(xl,yl,r,g,b); 	
          Dest->DrawPixel(x,y,r,g,b);			
      }

    }

  }

}

void display() 
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
	
	
	double hw=Camera->SizeX()*1.0/Camera->SizeY()/2;

	// apply the distortion on camera image and copy the result to the copy
	RadialDistortion(Camera, ImageCopy);

	Camera->DrawLineH(Camera->SizeY()*0.8,0,Camera->SizeX(),255,0,0);
	Camera->DrawLineV(Camera->SizeX()*0.95,0,Camera->SizeY(),0,255,0);
	Camera->Display();

	ImageCopy->DrawLineH(ImageCopy->SizeY()*0.8,0,ImageCopy->SizeX(),255,0,0);
	ImageCopy->DrawLineV(Camera->SizeX()*0.95,0,Camera->SizeY(),0,255,0);
	ImageCopy->Display();


	glutSwapBuffers();
}

void parsekey(unsigned char key, int x, int y)
{
	switch (key) {
	case 27: 
		delete Camera;
		//   CoUninitialize();
		exit(1);
	case ' ':
		break;
	case 's':
		break;
	default:
		glutPostRedisplay();
		return;
	}
}

// **********************************************************************
//  void reshape( int w, int h )
//		trata o redimensionamento da janela OpenGL
//
// **********************************************************************
void reshape( int w, int h )
{

	// Reset the coordinate system before modifying
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	// Set the viewport to be the entire window
    glViewport(0, 0, w, h);
	gluOrtho2D(0,w,0,h);

	// Set the clipping volume
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();


}

int main(int argc, char* argv[])
{
	//  CoInitialize(NULL);
	
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DEPTH | GLUT_RGB | GLUT_DOUBLE | GLUT_MULTISAMPLE | GLUT_STENCIL);
	glutInitWindowPosition(0, 0);
	glutInitWindowSize(1024, 512);
	glutCreateWindow("Radial Dist");
	glutDisplayFunc(display);
	glutKeyboardFunc(parsekey);
	glutReshapeFunc ( reshape );
	glutIdleFunc(myIdle);
	
	
	Camera = new CameraClass(0);
	Camera->SetPos(1,0);


	ImageCopy = new ImageClass(Camera->SizeX(), Camera->SizeY());
	ImageCopy->SetPos(Camera->SizeX()+10,0);

	glutMainLoop();
	
	return 1;
}
