// ************************************************
// SecondSmallVR.cpp
//	Sample file for SmallVR
//
//  Author: Marcio Serolli Pinho
//	Email: pinho@inf.pucrs.br		 
//	Homepages:
//		http://www.smallvr.org
//		http://grv.inf.pucrs.br
//		http://www.inf.pucrs.br/~pinho
//
//	Porto Alegre, Brazil, 2002.
// ************************************************

#ifdef WIN32
#include <windows.h>
#endif

#include <GL\gl.h>

// SmallVR header file
#include "SmVR.h"

float WindowRatio;

SmVR_CPoint	User(0,0,10);

// Root Object to represent the entire scene
SmVR_CGeometricObject *RootObject;

// **********************************************************************
// int DrawTest(void *p)
//
// **********************************************************************
int DrawGrid(void *p) 
{ 
	int N=10;
	glColor3f(1,1,0);
	glBegin (GL_LINES); 
		for (int k=-N;k <N;k++)
		{
			glVertex3f(-10,k,0); 
			glVertex3f(10,k,0);
			glVertex3f(k,-10,0); 
			glVertex3f(k,10,0);
		}
	glEnd(); 

  return 1;
}

// **********************************************************************
// int DrawTest(void *p)
//
// **********************************************************************
int DrawAxis(void *p) 
{ 
	glColor3f(0,1,0);
	glBegin (GL_LINES); 
		glVertex3f(-10,0,2); 
		glVertex3f(10,0,2); 
		glVertex3f(0,-10,2); 
		glVertex3f(0,10,2); 
	glEnd(); 

  return 1;
}

// **********************************************************************
// int DrawTest(void *p)
//
// **********************************************************************
int DrawTRI(void *p) 
{ 
	glColor3f(0,0,1);
	// Draw a triangle
	glBegin (GL_TRIANGLES); 
		glVertex3f(0,0,0); 
		glVertex3f(10,0,0); 
		glVertex3f(5,10,0); 
	glEnd(); 

  return 1;
}


// **********************************************************************
// int DrawTest(void *p)
//
// **********************************************************************
int DrawRECT(void *p) 
{ 

	glColor3f(1,0,0);
	// Draw a triangle
	glBegin (GL_QUADS); 
		glVertex3f(0,0,0); 
		glVertex3f(5,0,0); 
		glVertex3f(5,10,0); 
		glVertex3f(0,10,0); 
	glEnd(); 

  return 1;
} 
 
// **********************************************************************
//  void PosicUser()
//
//
// **********************************************************************
void PosicUser()
{
	// Set the clipping volume
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(90,WindowRatio,0.01,200);

	// Set the user Position
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(User.X,User.Y, User.Z,
		      User.X,User.Y, User.Z-3,
			  0.0f,1.0f,0.0f);
}
// **********************************************************************
//  void reshape( int w, int h )
//		trata o redimensionamento da janela OpenGL
//
// **********************************************************************
void reshape( int w, int h )
{
	// Prevent a divide by zero, when window is too short
	// (you cant make a window of zero width).
	if(h == 0)
		h = 1;

	WindowRatio = 1.0f * w / h;
	// Reset the coordinate system before modifying
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	// Set the viewport to be the entire window
    glViewport(0, 0, w, h);

	PosicUser();

}
// **********************************************************************
//  void display( void )
//
//
// **********************************************************************
void display( void )
{

	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

	PosicUser();

	glMatrixMode(GL_MODELVIEW);

	RootObject->Render();
	
	glutSwapBuffers();
}
// **********************************************************************
//  void keyboard ( unsigned char key, int x, int y )   
//
// **********************************************************************

GLfloat Color[3];

void keyboard ( unsigned char key, int x, int y )  
{
	SmVR_CGeometricObject *temp1;
	SmVR_CPoint Zero(0,0,0), GlobalPoint;

	temp1 = RootObject->FindChildObject("Triangle Object");
	switch ( key ) 
	{
	    case 27:   
			exit(0);   
			break;  
		case 'r': // Set RED
			Color[0] = 1.0f; Color[1] = 0.0f; Color[2] = 0.0f;
			temp1->SetRenderFunctionData(Color);
			break;
		case 'g': // Set GREEN
			Color[0] = 0.0f; Color[1] = 1.0f; Color[2] = 0.0f;
			temp1->SetRenderFunctionData(Color);
			break;
		case 'b': // Set BLUE
			Color[0] = 0.0f; Color[1] = 0.0f; Color[2] = 1.0f;
			temp1->SetRenderFunctionData(Color);
			break;
		case 'p': // get Point
			temp1->GetPointInOCS(Zero, &GlobalPoint, RootObject); 
			//RootObject->GetPointInOCS(&GlobalPoint, &Zero, temp1); 

			break;

	}
}
// **********************************************************************
//  void init(void)
//		Inicializa os parmetros globais de OpenGL
//
// **********************************************************************
void init(void)
{
	glClearColor(0.0f, 0.0f, 0.0f, 1.0f); // Fundo de tela preto
	glColorMaterial ( GL_FRONT, GL_AMBIENT_AND_DIFFUSE );

	glShadeModel(GL_SMOOTH);						
	glColorMaterial ( GL_FRONT, GL_AMBIENT_AND_DIFFUSE );
	glEnable(GL_DEPTH_TEST);
	glEnable ( GL_CULL_FACE );
	glPolygonMode (GL_FRONT_AND_BACK , GL_LINE);
}

// **********************************************************************
//  void main ( int argc, char** argv )
//
//
// **********************************************************************
void main ( int argc, char** argv )   
{
	SmVR_CGeometricObject *TestObject, *QuadObject;

	// GLUT initialization
	glutInit            ( &argc, argv ); 
	glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);// | GLUT_DOUBLE | GLUT_RGBA ); 
	glutInitWindowPosition (0,0);
	glutInitWindowSize  ( 700, 500 ); 
	glutCreateWindow    ( "SmallVR Test" ); 
		
	// initialize OpenGL parameters
	init ();

	// initialize the library
	RootObject = SmVR_Init(NULL);

	RootObject->AddChild(new SmVR_CGeometricObject("Grid",DrawGrid));
	
	// create and add XY Axis
	RootObject->AddChild(new SmVR_CGeometricObject("Axis Object",DrawAxis));

	// Create a triangle
	TestObject = new SmVR_CGeometricObject("Triangle Object", DrawTRI);

	// Add the object to the scene
	RootObject->AddChild(TestObject);
	
	TestObject->TranslateBy(2,2,0);

	QuadObject = new SmVR_CGeometricObject("Quad Object", DrawRECT);

	TestObject->AddChild(QuadObject);

	TestObject->RotateBy(180,0,0,1);

	QuadObject->TranslateToOnOBJCS(1,1,0,TestObject);

	//TestObject->RotateBy(45,0,0,1);

	// GLUT stuff
	glutDisplayFunc ( display );  
	glutReshapeFunc ( reshape );
	glutKeyboardFunc ( keyboard );
	glutIdleFunc ( display );

	glutMainLoop ( );          

}



