// ************************************************
// TesteISOTRACKII.cpp
//	  Sample file for SmallVR
//
//	This example shows how to use the POLHEMUS 
//	ISOTRACK tracker in SmallVR
//
//
//  Author: Marcio Serolli Pinho
//	Email: pinho@inf.pucrs.br		 
//	Homepages:
//		http://www.smallvr.org
//		http://grv.inf.pucrs.br
//		http://www.inf.pucrs.br/~pinho
//
//	Porto Alegre, Brazil, 2002.
// ************************************************

#ifdef WIN32
#include <windows.h>
#endif

#include "..\source\SmVR.h"   // it includes all GL and GLUT headers

//#include "..\Source\3DLoaders\3ds\SmVR_C3DSLoader.h"
#include "..\Source\Devices\IsotrackII\SmVR_CIsotrack.h"
#include "..\Source\Devices\FakeTracker\SmVR_CFakeTracker.h"

float TX=0;


#define HALF_EGDE_LENGHT 1

GLfloat ratio=1;  
SmVR_CPoint	User(0,0,10);
;

int ObjFree = true;

SmVR_CGeometricObject *RootObject;

SmVR_CGeometricObject *TestObject;

SmVR_CGeometricObject *TrackerObject;

SmVR_CDevice *Isotrack;

SmVR_CGeometricObject *Hand, *Stick, *Fish;


GLfloat Vermelho[3]= { 1,0,0 };
GLfloat Azul[3]= { 0,0,1 };
GLfloat Verde[3]= { 0,1,0 };
GLfloat Amarelo[3]= { 1,1,0 };
GLfloat Marrom[3]= { 0.3f,0.5f,0.8f };

GLint window;



// **********************************************************************
//  void DefineLuz(void)
//
//
// **********************************************************************
void DefineLuz(void)
{
  // Define cores para um objeto dourado
  GLfloat LuzAmbiente[]   = {0.5f, 0.5f, 0.8f } ;
  GLfloat LuzDifusa[]   = {0.5f, 0.5f, 0.8f, 1.0f };
  GLfloat LuzEspecular[] = {0.8f, 0.8f, 0.8f, 1.0f };
  GLfloat PosicaoLuz0[]  = {0.0f, 1.0f, 0.0f, 1.0f };

   // ****************  Fonte de Luz 0

  glEnable ( GL_COLOR_MATERIAL );

   // Habilita o uso de iluminao
  glEnable(GL_LIGHTING);

  // Ativa o uso da luz ambiente
  glLightModelfv(GL_LIGHT_MODEL_AMBIENT, LuzAmbiente);
  // Define os parametros da Luz nmero Zero
  glLightfv(GL_LIGHT0, GL_AMBIENT, LuzAmbiente);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, LuzDifusa  );
  glLightfv(GL_LIGHT0, GL_SPECULAR, LuzEspecular  );
  glLightfv(GL_LIGHT0, GL_POSITION, PosicaoLuz0 );
  glEnable(GL_LIGHT0);

}
// **********************************************************************
//  void DesenhaCubo()
//
//
// **********************************************************************
int DesenhaCubo(void *p)
{
	
	glColor3fv((GLfloat *)p);
	glBegin ( GL_QUADS );
		// Front Face
		glNormal3f(0,0,1);
		glVertex3f(-HALF_EGDE_LENGHT, -HALF_EGDE_LENGHT,  HALF_EGDE_LENGHT);
		glVertex3f( HALF_EGDE_LENGHT, -HALF_EGDE_LENGHT,  HALF_EGDE_LENGHT);
		glVertex3f( HALF_EGDE_LENGHT,  HALF_EGDE_LENGHT,  HALF_EGDE_LENGHT);
		glVertex3f(-HALF_EGDE_LENGHT,  HALF_EGDE_LENGHT,  HALF_EGDE_LENGHT);
		// Back Face
		glNormal3f(0,0,-1);
		glVertex3f(-HALF_EGDE_LENGHT, -HALF_EGDE_LENGHT, -HALF_EGDE_LENGHT);
		glVertex3f(-HALF_EGDE_LENGHT,  HALF_EGDE_LENGHT, -HALF_EGDE_LENGHT);
		glVertex3f( HALF_EGDE_LENGHT,  HALF_EGDE_LENGHT, -HALF_EGDE_LENGHT);
		glVertex3f( HALF_EGDE_LENGHT, -HALF_EGDE_LENGHT, -HALF_EGDE_LENGHT);
		// Top Face
		glNormal3f(0,1,0);
		glVertex3f(-HALF_EGDE_LENGHT,  HALF_EGDE_LENGHT, -HALF_EGDE_LENGHT);
		glVertex3f(-HALF_EGDE_LENGHT,  HALF_EGDE_LENGHT,  HALF_EGDE_LENGHT);
		glVertex3f( HALF_EGDE_LENGHT,  HALF_EGDE_LENGHT,  HALF_EGDE_LENGHT);
		glVertex3f( HALF_EGDE_LENGHT,  HALF_EGDE_LENGHT, -HALF_EGDE_LENGHT);
		// Bottom Face
		glNormal3f(0,-1,0);
		glVertex3f(-HALF_EGDE_LENGHT, -HALF_EGDE_LENGHT, -HALF_EGDE_LENGHT);
		glVertex3f( HALF_EGDE_LENGHT, -HALF_EGDE_LENGHT, -HALF_EGDE_LENGHT);
		glVertex3f( HALF_EGDE_LENGHT, -HALF_EGDE_LENGHT,  HALF_EGDE_LENGHT);
		glVertex3f(-HALF_EGDE_LENGHT, -HALF_EGDE_LENGHT,  HALF_EGDE_LENGHT);
		// Right face
		glNormal3f(1,0,0);
		glVertex3f( HALF_EGDE_LENGHT, -HALF_EGDE_LENGHT, -HALF_EGDE_LENGHT);
		glVertex3f( HALF_EGDE_LENGHT,  HALF_EGDE_LENGHT, -HALF_EGDE_LENGHT);
		glVertex3f( HALF_EGDE_LENGHT,  HALF_EGDE_LENGHT,  HALF_EGDE_LENGHT);
		glVertex3f( HALF_EGDE_LENGHT, -HALF_EGDE_LENGHT,  HALF_EGDE_LENGHT);
		// Left Face
		glNormal3f(-1,0,0);
		glVertex3f(-HALF_EGDE_LENGHT, -HALF_EGDE_LENGHT, -HALF_EGDE_LENGHT);
		glVertex3f(-HALF_EGDE_LENGHT, -HALF_EGDE_LENGHT,  HALF_EGDE_LENGHT);
		glVertex3f(-HALF_EGDE_LENGHT,  HALF_EGDE_LENGHT,  HALF_EGDE_LENGHT);
		glVertex3f(-HALF_EGDE_LENGHT,  HALF_EGDE_LENGHT, -HALF_EGDE_LENGHT);
	glEnd();

	//printf("%s\n", (char*)p);

	return 0;
}


// **********************************************************************
//  void PosicUser()
//
//
// **********************************************************************
void PosicUser()
{
	// Set the clipping volume
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(90,ratio,0.01,200);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(User.X,User.Y, User.Z,
		      User.X,User.Y, User.Z-3,
			  0.0f,1.0f,0.0f);
}
// **********************************************************************
//  void reshape( int w, int h )
//		trata o redimensionamento da janela OpenGL
//
// **********************************************************************
void reshape( int w, int h )
{

	// Prevent a divide by zero, when window is too short
	// (you cant make a window of zero width).
	if(h == 0)
		h = 1;

	ratio = 1.0f * w / h;
	// Reset the coordinate system before modifying
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	// Set the viewport to be the entire window
    glViewport(0, 0, w, h);

	PosicUser();

}
// **********************************************************************
//  void display( void )
//
//
// **********************************************************************
void display( void )
{
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

	DefineLuz();

	PosicUser();

	glMatrixMode(GL_MODELVIEW);

	// Read the data from the tracker and
	// update all the BIND objects
	Isotrack->UpdateAllSensors();

	TrackerObject->TranslateBy(TX,0,0);

	RootObject->Render();

	glutSwapBuffers();
	glutPostRedisplay();
}

void idle( void )
{
	glutSetWindow(window);
	glutPostRedisplay();
}



// **********************************************************************
//  void keyboard ( unsigned char key, int x, int y )
//
//
// **********************************************************************
void keyboard ( unsigned char key, int x, int y )  
{


	switch ( key ) 
	{
	    case 27:   
			delete Isotrack; // Termina o programa qdo
			exit(0);         // a tecla ESC for pressionada
			break;  
		case 'r':// Call Isotrack reset function
			Isotrack->Reset(NULL);
			break;

		case 'a':
			TX--;
			break;
		case 's':
			//Hand->TranslateBy(1,0,0);;
			TX++;
			break;

	    default:  
			printf("Tecla invlida: %d\n", key);
		  break;
  }
}

// **********************************************************************
//  void arrow_keys ( int a_keys, int x, int y )  
//
//
// **********************************************************************
void arrow_keys ( int a_keys, int x, int y )  
{
	switch ( a_keys ) 
	{
		case GLUT_KEY_UP:       // When Up Arrow Is Pressed...
			break;
	    case GLUT_KEY_DOWN:     // When Down Arrow Is Pressed...
			break;
		default:
			break;
	}
}
// **********************************************************************
//  void init(void)
//		Inicializa os parmetros globais de OpenGL
//
// **********************************************************************
void init(void)
{
	glClearColor(0.0f, 0.0f, 0.0f, 1.0f); // Fundo de tela preto
	glColorMaterial ( GL_FRONT, GL_AMBIENT_AND_DIFFUSE );

	glShadeModel(GL_SMOOTH);						
	glColorMaterial ( GL_FRONT, GL_AMBIENT_AND_DIFFUSE );
	glEnable(GL_DEPTH_TEST);
	glEnable ( GL_CULL_FACE );

}

// **********************************************************************
// **********************************************************************
int f_UM(void *p)
{
	printf("Desenhando:%s\n", (char *)p);
	return 0;
}
// **********************************************************************
//  void main ( int argc, char** argv )
//
//
// **********************************************************************


void main ( int argc, char** argv )   
{

	SmVR_CPoint P1(0,0,0),
				P2;

	glutInit            ( &argc, argv ); 
	glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);// | GLUT_DOUBLE | GLUT_RGBA ); 
	glutInitWindowPosition (0,0);
	glutInitWindowSize  ( 700, 500 ); 
	window = glutCreateWindow    ( "SmallVR Test" ); 
		
	init ();

	// Initialize SmallVR
	RootObject = SmVR_Init(NULL);

	// Initialize the tracker device
	Isotrack = new SmVR_CIsotrack();
	//Isotrack = new SmVR_CFakeTracker();
	Isotrack->Init("COM1");

	// Create an object to be BIND to the tracker
	TrackerObject = new SmVR_CGeometricObject("TrackerObject");
	RootObject->AddChild(TrackerObject);

	// Bind it to Isotrack tracker number 1	
	Isotrack->Bind(0, TrackerObject);
	Isotrack->Reset(NULL);

	// Create the hand 
	Hand = new SmVR_CGeometricObject("Hand", DesenhaCubo);
	Hand->SetRenderFunctionData(Verde);
	Hand->TranslateBy(0,0,0);

	// Make the 'Hand' object child of the tracked object
	TrackerObject->AddChild(Hand);

	Stick = new SmVR_CGeometricObject("Stick", DesenhaCubo);
	Stick->SetRenderFunctionData(Amarelo);
	
	// Ajust the size/scale of the stick
	Stick->ScaleBy(0.5,0.5,5);
	Stick->TranslateBy(0,0,-5);
	Hand->AddChild(Stick);
	
	// Create the fish objects
	Fish = new SmVR_CGeometricObject("Fish", DesenhaCubo);
	Fish->SetRenderFunctionData(Azul);
	Stick->AddChild(Fish);
	Fish->TranslateBy(0,-1.5,-2.0);
	
	glutDisplayFunc(display);  
	glutReshapeFunc(reshape);
	glutKeyboardFunc(keyboard);
	glutSpecialFunc(arrow_keys);
	glutIdleFunc(idle);

	glutMainLoop();          

}




