/*****************************************************
 **
 **  
 **
 **  File: 
 **
 **  Author: Virtual Reality Group - FACIN - PUCRS - BRAZIL
 **  Mail: trombetta@inf.pucrs.br
 **  Version: 0.1
 **  Last Update:  21/07/06 16:
 **
 *****************************************************/


//#define DEBUG



#include <windows.h>
#include <GL\gl.h>
#include <iostream>
#include "glut.h""
#include "SmVR.h"
#include "..\Source\CollisionDetection\timer.h"
#include "OBJ\SmVR_COBJLoader.h"
#include "Devices\IGlasses\SmVR_CIGlasses.h"
#include "Stereo\StereoIglasses.h"
#include "..\Source\CollisionDetection\SmVR_CEnvelope.h"
#include "ArcBall.h"



float blue		[3] = { 0, 0, 1};
float white		[3] = { 1, 1, 1};
float green		[3] = { 0,.8, 0};
float red		[3] = { 1, 0, 0};
float yellow	[3] = { 1, 1, 0};
float gray		[3] = {.5,.5,.5};
float black		[3] = { 0, 0, 0};

SmVR_CPoint Zero(0, 0, 0);
SmVR_CPoint *pt_user = new SmVR_CPoint();
SmVR_CPoint *pt_target = new SmVR_CPoint();

SmVR_CGeometricObject *RootObject, *userParent, *user, *target, *Object, *ObjectBB, *ObjectCT, *ObjectTrans, *Help, *Cmd;


int MouseX, MouseY, modifier = 0;
float frameRate = 0;
typedef enum Mode{
	ROTATE,
	TRANSLATE,
	ZOOM,
	SCALE
};

char fileName[100];

bool Wired = false, BBVis = false, help = false;
Mode CurrentMode = ROTATE;

//ARCBALL
ArcBallT ArcBall(800,600);
Point2fT MousePt;
bool isClicked;
bool isDragging;
Matrix4fT Transform;
Matrix3fT LastRot;
Matrix3fT ThisRot;
//END ARCBALL


Timer	timerRefresh;

GLint window;

GLint	especMaterial = 60;
GLfloat	lightPosition1	[4] = { 100.0, 300.0,	0.0, 1.0};
GLfloat	ambient			[4] = { 0.4,	 0.4,	0.4, 1.0};
GLfloat	diffuse			[4] = { 0.7,	 0.7,	0.7, 1.0}; // ambient "color"
GLfloat	specular		[4] = { 0.5,	 0.5,	0.5, 1.0}; // ambient shininess
GLfloat	specularity		[4] = { 0.17,	 0.17, 0.17, 1.0}; // ambient specularity

GLfloat	angle = 60, nearVal = .1, WindowRatio, farVal = 500;

void initArcball(int w, int h)
{
	

	isClicked  = false;
//    isRClicked = false;
    isDragging = false;

    Transform.M[0]  = 1.0f; LastRot.M[0] = 1.0f; ThisRot.M[0] = 1.0f;
    Transform.M[1]  = 0.0f; LastRot.M[1] = 0.0f; ThisRot.M[1] = 0.0f;
    Transform.M[2]  = 0.0f; LastRot.M[2] = 0.0f; ThisRot.M[2] = 0.0f;
    Transform.M[3]  = 0.0f; LastRot.M[3] = 0.0f; ThisRot.M[3] = 0.0f;
    Transform.M[4]  = 0.0f; LastRot.M[4] = 1.0f; ThisRot.M[4] = 1.0f;
    Transform.M[5]  = 1.0f; LastRot.M[5] = 0.0f; ThisRot.M[5] = 0.0f;
    Transform.M[6]  = 0.0f; LastRot.M[6] = 0.0f; ThisRot.M[6] = 0.0f;
    Transform.M[7]  = 0.0f; LastRot.M[7] = 0.0f; ThisRot.M[7] = 0.0f;
    Transform.M[8]  = 0.0f; LastRot.M[8] = 1.0f; ThisRot.M[8] = 1.0f;
    Transform.M[9]  = 0.0f;
    Transform.M[10] = 1.0f;
    Transform.M[11] = 0.0f;
    Transform.M[12] = 0.0f;
    Transform.M[13] = 0.0f;
    Transform.M[14] = 0.0f;
    Transform.M[15] = 1.0f;
}


int drawBB(void *p){
	SmVR_CPoint min, max;
	SmVR_CObjFromFile *obj;

	if(p)
	{
        obj = (SmVR_CObjFromFile*)p;
		obj->GetBoundaries(&min, &max);
	}

	glColor3f(1, 0, 0);
	glBegin(GL_LINES);
		glVertex3f(min.X, min.Y, min.Z);
		glVertex3f(max.X, min.Y, min.Z);

		glVertex3f(min.X, min.Y, min.Z);
		glVertex3f(min.X, min.Y, max.Z);

		glVertex3f(min.X, min.Y, min.Z);
		glVertex3f(min.X, max.Y, min.Z);

		glVertex3f(min.X, min.Y, max.Z);
		glVertex3f(max.X, min.Y, max.Z);

		glVertex3f(min.X, min.Y, max.Z);
		glVertex3f(min.X, max.Y, max.Z);

		glVertex3f(min.X, max.Y, max.Z);
		glVertex3f(max.X, max.Y, max.Z);

		glVertex3f(min.X, max.Y, max.Z);
		glVertex3f(min.X, max.Y, min.Z);

		glVertex3f(min.X, max.Y, min.Z);
		glVertex3f(max.X, max.Y, min.Z);

		glVertex3f(max.X, max.Y, min.Z);
		glVertex3f(max.X, max.Y, max.Z);

		glVertex3f(max.X, max.Y, min.Z);
		glVertex3f(max.X, min.Y, min.Z);

		glVertex3f(max.X, min.Y, min.Z);
		glVertex3f(max.X, min.Y, max.Z);

		glVertex3f(max.X, min.Y, max.Z);
		glVertex3f(max.X, max.Y, max.Z);
	glEnd();
	return 1;
}

GLTexture *thelp;
int drawHelp(void *p)
{
	if(!thelp){
		thelp = new GLTexture();
		thelp->Load("../testfiles/about.jpg");
	}
	thelp->Use();
	glColor3f(1,1,1);
	glBegin(GL_QUADS);
		glTexCoord2f (0.0, 0.0); glVertex3f(-10, -10, -10);
		glTexCoord2f (0.0, 1.0); glVertex3f(-10,  10, -10);
		glTexCoord2f (1.0, 1.0); glVertex3f( 10,  10, -10);
		glTexCoord2f (1.0, 0.0); glVertex3f( 10, -10, -10);
	glEnd();
	return 1;
}
char vet[30];
char *a;
int drawCmd(void *p)
{
	memset(vet, 0x0, 30);
	strcpy(vet, "CTRL - ZOOM  |  ALT - Move");
	glColor3f(1, 1, 0);
	//glRasterPos3f(-.075, -.055, 69.9);
	glRasterPos3f(0, 0, 0);
	for(a=vet; (*a) != '\0'; a++)
		glutBitmapCharacter(GLUT_BITMAP_HELVETICA_12, *a);
	return 1;
}


void loadObject(char* obj)
{
	SmVR_CObjFromFile *ObjectFromFile;
	SmVR_CPoint pt_min, pt_max;
	float x, y, z, scale;

	ObjectFromFile = new SmVR_COBJLoader();
	if(!ObjectFromFile->Load(obj))
	{
		system("pause");
		exit(1);
	}
	ObjectFromFile->GetBoundaries(&pt_min, &pt_max);
	//printf("min(%f, %f, %f) max(%f, %f, %f)\n", pt_min.X, pt_min.Y, pt_min.Z, pt_max.X, pt_max.Y, pt_max.Z);
	
	x = (pt_min.X > 0 ? pt_min.X : -pt_min.X) + (pt_max.X > 0 ? pt_max.X : -pt_max.X);
	y = (pt_min.Y > 0 ? pt_min.Y : -pt_min.Y) + (pt_max.X > 0 ? pt_max.Y : -pt_max.Y);
	z = (pt_min.Z > 0 ? pt_min.Z : -pt_min.Z) + (pt_max.X > 0 ? pt_max.Z : -pt_max.Z);

	if(x > y && x > z) scale = 50 / x;
	  else if(y > x && y > z) scale = 50 / y;
	    else scale = 50 / z;
	
	delete Object;
	delete ObjectBB;
	ObjectCT = new SmVR_CGeometricObject("ObjectCT");
	Object = new SmVR_CGeometricObject("Object", ObjectFromFile);
	ObjectBB = new SmVR_CGeometricObject("ObjectBB", drawBB);
	ObjectBB->SetVisibility(0);
	ObjectTrans = new SmVR_CGeometricObject("ObjectBB", drawBB);
	ObjectBB->SetRenderFunctionData(ObjectFromFile);

	//ObjectCT->TranslateBy(0, 0, (z/2));
	//user->TranslateBy(0, 0, 70-(z*scale)/2);
	
	RootObject->AddChild(ObjectTrans);
	ObjectTrans->AddChild(ObjectCT);
	ObjectCT->AddChild(Object);
	Object->AddChild(ObjectBB);
	
	Object->ScaleBy(scale, scale, scale);
	Object->TranslateBy((x*scale)/2 - (pt_max.X*scale), (y*scale)/2 - (pt_max.Y*scale), 0);
	userParent->TranslateBy(0, 0, 70);
}

//ARCBALL
void Transf() {
    //do the transformation, applying Transform.M
    GLfloat aux[4][4];
    memcpy(aux, Transform.M, sizeof(GLfloat)*16);
    SmVR_CGeometricObject *f = (RootObject->FindChildObject("ObjectCT"));
    if (f)
        f->SetLocalTransformationMatrix(aux);
}
//END ARCBALL



/************************************************
 ** void SetWindowTitle()
 ************************************************/
void SetWindowTitle(){
	char title[200];
	sprintf(title,"Object Vizualiser %.2f frames/second ",frameRate);
	glutSetWindowTitle(title);
}

/************************************************
 ** void PosicUser()
 ************************************************/
void PosicUser() {
	glutSetWindow(window);
	// Set the clipping volume
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(angle, WindowRatio, nearVal, farVal);

	// especifies the coordenate system
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	lightPosition1[0] = pt_target->X;
	lightPosition1[2] = pt_target->Z;
	glLightfv(GL_LIGHT0, GL_POSITION, lightPosition1);
	gluLookAt(pt_user->X, pt_user->Y, pt_user->Z,		// User postition
			  pt_target->X, pt_target->Y, pt_target->Z, // Target position
			  0.0f, 1.0f, 0.0f);			 // Define upper side

}

/************************************************
 ** void ChangeSize(GLsizei w, GLsizei h)
 **
 ** reset the window size
 **
 ************************************************/
void ChangeSize(GLsizei w, GLsizei h) {
	// Prevent a division by zero, when window is too short
	// (you can't make a window of zero width)
	if(h == 0)
		h = 1;

	WindowRatio = 1.0f * w / h;
	glutSetWindow(window);
	// Reset the coordinate system before modifying
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	// Set the viewport to be the entire window
	glViewport(0, 0, w, h);
	PosicUser();
	Cmd->TranslateToOnOBJCS((w/800.0) < 1 ?  (w/800.0) * -0.075 : (w/800.0) * -0.075, 
		                    (h/600.0) < 1 ?  (h/600.0) * -0.055 : (h/600.0) * -0.055, 
							69.9, RootObject);
	printf("W: %f  H: %f\n", (w/800.0-1)*0.075, (h/600.0-1)*0.055);
}

/************************************************
 ** void SetupRC()
 **
 ** setup rendering context
 **
 ************************************************/
void SetupRC() {
	glShadeModel(GL_SMOOTH);
	glClearColor(0.4f, 0.5f, 1.0f, 1.0f); //backgroung color
	glColorMaterial(GL_FRONT, GL_AMBIENT_AND_DIFFUSE);

	glMaterialfv(GL_FRONT,GL_SPECULAR, specularity);
	glMateriali(GL_FRONT,GL_SHININESS,especMaterial);
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, ambient);

	glLightfv(GL_LIGHT0, GL_AMBIENT , ambient );
	glLightfv(GL_LIGHT0, GL_DIFFUSE , diffuse   );
	glLightfv(GL_LIGHT0, GL_SPECULAR, specular);
	glLightfv(GL_LIGHT0, GL_POSITION, lightPosition1 );

	glEnable(GL_COLOR_MATERIAL);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_NORMALIZE);
//	glEnable(GL_CULL_FACE);

}

/************************************************
 ** void updatePosition()
 ************************************************/
void updatePosition()
{	
	userParent->GetPointInOCS(Zero, pt_user, RootObject);
	target->GetPointInOCS(Zero, pt_target, RootObject);
	glutSetWindow(window); // reshape main window
	glutPostRedisplay();
}


/************************************************
 ** void RenderScene(void)
 ************************************************/
void RenderScene(void) {
	frameRate = 1/timerRefresh.partial();
	timerRefresh.start();

	if(Wired) glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
	  else glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);

	SetWindowTitle();

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

    RootObject->Render();
    PosicUser();
    glutSwapBuffers();
}

/************************************************
 ** void keyboard(unsigned char key, int x, int y)
 ************************************************/
void keyboard(unsigned char key, int x, int y)
{
     
	switch(key) {
    	case 27: exit(1); break;// ESC quits program execution
		case 'b': case 'B':
			BBVis = !BBVis;
			ObjectBB->SetVisibility(BBVis);
			break;
		case 't': case 'T':
			CurrentMode = TRANSLATE;
			break;
		case 'r': case 'R':
			CurrentMode = ROTATE;
			break;
    	default:break;
	}
}

/************************************************
 ** void SpecialKeys(int key, int x, int y)
 ************************************************/
void SpecialKeys(int key, int x, int y)
{
  //SmVR_CGeometricObject *userParent = RootObject->FindChildObject("userParent");

	switch(key) {
	case GLUT_KEY_F1:
		help = !help;
		Help->SetVisibility(help);
	}
}

/**************************************************
 ** void MouseClick(int button, int state, int x, int y)
 **
 **
 **************************************************/
void MouseClick(int button, int state, int x, int y)
{
	if(state == GLUT_DOWN)
		modifier = glutGetModifiers();
	else modifier = 0;
	switch(button){
	case GLUT_LEFT_BUTTON: 
		if(state == GLUT_DOWN)
		{
			MouseX = x;
			MouseY = y;
			isClicked = true;
		}else
            isDragging = false;
		break;
	case GLUT_RIGHT_BUTTON:	break;
	/*case GLUT_WHEEL_UP: 
		ObjectCT->TranslateBy(0, 0, 1);
		break;
	case GLUT_WHEEL_DOWN: 
		ObjectCT->TranslateBy(0, 0, -1);
		break;*/
	default: break;
	}

}

void motion(int x, int y)
{
    MousePt.s.X = (float)x;
    MousePt.s.Y = (float)y;


	switch(modifier)
	{
		case GLUT_ACTIVE_ALT:
			if(MouseX < x)
			{
				ObjectTrans->TranslateBy((x-MouseX)/7.5, 0, 0);
			}
			else if(MouseX > x)
			{
				ObjectTrans->TranslateBy((x-MouseX)/7.5, 0, 0);
			}
			if(MouseY < y) ObjectTrans->TranslateBy(0, -(y-MouseY)/7.5, 0);
				else if(MouseY > y) ObjectTrans->TranslateBy(0, -(y-MouseY)/7.5, 0);
			break;
		case GLUT_ACTIVE_CTRL:
			if(MouseY < y) ObjectTrans->ScaleBy(1.1, 1.1, 1.1);
			  else if(MouseY > y) ObjectTrans->ScaleBy(.9, .9, .9);
			break;
		default:
			//Arcball...
            if (!isDragging) {
                if (isClicked) {
        			isClicked = false;
                    isDragging = true;
        			LastRot = ThisRot;
                    ArcBall.click(&MousePt);
                }
            }
            else {
                Quat4fT ThisQuat;
                ArcBall.drag(&MousePt, &ThisQuat);
                Matrix3fSetRotationFromQuat4f(&ThisRot, &ThisQuat);
                Matrix3fMulMatrix3f(&ThisRot, &LastRot);
                Matrix4fSetRotationFromMatrix3f(&Transform, &ThisRot);
                Transf();
            }
             break;
	}
	MouseX = x;
	MouseY = y;
}



void mainMenu(int opt)
{
	switch(opt)
	{
	case 1:
		Wired = !Wired;
		break;
	case 2:
		BBVis = !BBVis;
		ObjectBB->SetVisibility(BBVis);
		break;
	case 3:
		exit(1);
		break;
	default:
		break;
	}
}


void initMenu()
{
	int id2 = glutCreateMenu(mainMenu);
	glutAddMenuEntry("Wireframe", 1);
	glutAddMenuEntry("Show/Hide Boundbox", 2);
	glutAddMenuEntry("Quit", 3);
	glutAttachMenu(GLUT_RIGHT_BUTTON);

	glutSetMenu(id2);
}


/************************************************
 ** int main(int argc, char **argv)
 ************************************************/
int main(int argc, char **argv) {

	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);

	glutInitWindowSize(800, 600);
	initArcball(800, 600);
	
	
	if(argc < 2)
	{
		std::cout << "FileName: ";
		std::cin.getline(fileName, 99);
	}else sprintf(fileName, "%s", argv[1]);


    window = glutCreateWindow(" ");

	// Initialize the Small VR library
	RootObject = SmVR_Init(NULL);

	initMenu();

	timerRefresh.start();

	

	user = new SmVR_CGeometricObject("user");

	userParent = new SmVR_CGeometricObject("userParent");
	target = new SmVR_CGeometricObject("target");

	target->TranslateBy(0, 0, -1);

    userParent->AddChild(user);
    user->AddChild(target);
	RootObject->AddChild(userParent);
	
	
	loadObject(fileName);

	Help = new SmVR_CGeometricObject("help", drawHelp);
	Help->SetVisibility(help);
	Help->TranslateBy(0, -2, 68);
	RootObject->AddChild(Help);
	RootObject->AddChild(Cmd = new SmVR_CGeometricObject("cmdList", drawCmd));
	Cmd->TranslateBy(-.075, -.055, 69.9);
	

	glutDisplayFunc(RenderScene);
	glutSpecialFunc(SpecialKeys);
	glutKeyboardFunc(keyboard);
	glutMouseFunc(MouseClick);
	glutReshapeFunc(ChangeSize);
	glutMotionFunc(motion);
	SetupRC();

	glutIdleFunc(updatePosition);
	glutMainLoop();
	return 0;
}
